package ecp.vcs.com.ecpsyncplugin.re_sync.database;

import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteException;
import android.database.sqlite.SQLiteOpenHelper;
import android.database.sqlite.SQLiteStatement;
import android.os.Build;
import android.text.TextUtils;
import android.util.Log;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Set;

import ecp.vcs.com.ecpsyncplugin.R;
import ecp.vcs.com.ecpsyncplugin.re_sync.SynchronizationService;
import ecp.vcs.com.ecpsyncplugin.re_sync.logging.LogHelper;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CityModel;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CtoEMapping;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CustomerDetail;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.BarcodeModel;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopDistributorDispatch;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.MenuAccess;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.ProductDetails;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.ScannedPoints;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.SchemeName;
import ecp.vcs.com.ecpsyncplugin.re_sync.networking.AppUtil;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.Const;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.Content;


public class DataBaseHelper extends SQLiteOpenHelper {

    //    Added By Chandan For Testing Purpose
//    public static final String KEY_BATCH_NO = "batch_no";
//    public static final String KEY_PRODUCT_SKU_COUNTRY_ID = "product_sku_country_id";

    private SQLiteDatabase database;
    private File databaseFile;
    public static final String IS_EXPIRE_ENABLE = "is_expire_enable";
    public static final String CHR_SCM_CPM = "chr_scm_cpm";
    public static final String INT_SYNC_ALERT_MINUTES = "int_sync_alert_bg_minutes";
    public static final String INT_SCAN_ALERT_MINUTES = "int_scan_alert_bg_minutes";
    public static final String INT_SALES_RET_LIMIT = "int_sales_return_limit";
    public static final String IS_SYNC_POPUP = "is_Sync_PopUp";
    public static final String CHAR_PALLATE_ENABLE = "chr_pallet_enable";
    public static final String INT_SCAN_SCREEN = "intScanScreen";
    public static final String INT_SYNC_MINUTES = "int_sync_minutes";
    public static final String DIST_DISPATCH_MAX_DATE = "dispatch_date";
    public static final String DIST_RETURN_REQUEST_MAX_DATE = "return_request_date";
    public static final String DIST_DAMAGE_MAX_DATE = "damage_date";
    public static final String DIST_RET_RETURN_MAX_DATE = "ret_return_date";
    public static final String CFA_DISPATCH_MAX_DATE = "cfa_dispatch_date";

    public static final String INT_MINIMUM_MINS = "int_minimum_minutes";
    public static final String INT_MAXIMUM_MINS = "int_maximum_minutes";
    public static final String CHR_SCAN_TYPE_RADIO_BTN = "chr_scan_type_radio_btn";

    public static final String FTP_HOST = "ftp_host";
    public static final String FTP_USERNAME = "ftp_username";
    public static final String FTP_PASSWORD = "ftp_password";
    public static final String FTP_PORT = "ftp_port";

    //    CFA Damage Table And product Table
    public static final String CFA_DAMAGE_PRODUCT_ID = "cfa_damage_product_id";
    public static final String CFA_DAMAGE_ID = "cfa_damage_id";
    public static final String DAMAGE_DATE = "damage_date";
    public static final String ISDAMAGE = "isDamage";

    //    For Distributor Damage
    public static final String DISTRIBUTOR_DAMAGE_PRODUCT_ID = "distributor_damage_product_id";
    public static final String DISTRIBUTOR_DAMAGE_ID = "distributor_damage_id";

    //    For Retailer Damage
    public static final String RETAILER_DAMAGE_PRODUCT_ID = "retailer_damage_product_id";
    public static final String RETAILER_DAMAGE_ID = "retailer_damage_id";

    public static final String TABLE_SCHEME_MASTER = "Scheme_Master";
    public static final String TABLE_CFA_DAMAGE = "bf_ishop_cfa_damage";
    public static final String TABLE_CFA_DAMAGE_COPY = "bf_ishop_cfa_damage_copy";
    public static final String TABLE_CFA_DAMAGE_PRODUCT = "bf_ishop_cfa_damage_product";
    public static final String TABLE_DISTRIBUTOR_DAMAGE = "bf_ishop_distributor_damage";
    public static final String TABLE_DISTRIBUTOR_DAMAGE_COPY = "bf_ishop_distributor_damage_copy";
    public static final String TABLE_DISTRIBUTOR_DAMAGE_PRODUCT = "bf_ishop_distributor_damage_product";
    public static final String TABLE_RETAILER_DAMAGE = "bf_ishop_retailer_damage";
    public static final String TABLE_RETAILER_DAMAGE_COPY = "bf_ishop_retailer_damage_copy";
    public static final String TABLE_RETAILER_DAMAGE_PRODUCT = "bf_ishop_retailer_damage_product";
    public static final String TABLE_EXTRA_STICKER = "extra_sticker_detail";
    public static final String TABLE_EXTRA_STICKER_COPY = "extra_sticker_detail_copy";

    public static final String TABLE_REJECTED_ORDER = "table_rejected_order";
    public static final String TABLE_DISPATCH_BATCHWISE_STOCK_CALCULATE = "table_dispatch_batchwise_stock_calculate";
    public static final String TABLE_SCANNEDSTICKERS = "table_scannedsticker";
    public static final String TABLE_CHECK_MAX_DATE = "table_check_max_date";
    public static final String TABLE_LAST_SYNC_SCAN_DATE = "bf_last_sync_scan_status";
    public static final String TABLE_TOLLER_DISPATCH = "bf_ishop_toller_dispatch";
    public static final String TABLE_TOLLER_DISPATCH_COPY = "bf_ishop_toller_dispatch_copy";
    public static final String TABLE_TOLLER_DISPATCH_PRODUCT = "bf_ishop_toller_dispatch_product";
    public static final String TABLE_TOLLER_DISPATCH_PRODUCT_COPY = "bf_ishop_toller_dispatch_product_copy";
    public static final String TABLE_CFA_DISPATCH = "bf_ishop_cfa_dispatch";
    public static final String TABLE_CFA_DISPATCH_COPY = "bf_ishop_cfa_dispatch_copy";
    // TABLE NAME
    public static final String TABLE_CFA_DISPATCH_PRODUCT = "bf_ishop_cfa_dispatch_product";
    public static final String TABLE_CFA_DISPATCH_PRODUCT_COPY = "bf_ishop_cfa_dispatch_product_copy";
    public static final String TABLE_DISTRIBUTOR_DISPATCH = "bf_ishop_distributor_dispatch";
    public static final String TABLE_DISTRIBUTOR_DISPATCH_COPY = "bf_ishop_distributor_dispatch_copy";
    public static final String TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = "bf_ishop_distributor_dispatch_product";
    public static final String TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY = "bf_ishop_distributor_dispatch_product_copy";
    public static final String TABLE_NEW_CUSTOMER = "bf_master_new_customer";
    public static final String TABLE_RETAILER_DISPATCH = "bf_ishop_retailer_dispatch";
    public static final String TABLE_RETAILER_DISPATCH_COPY = "bf_ishop_retailer_dispatch_copy";
    public static final String TABLE_RETAILER_DISPATCH_PRODUCT = "bf_ishop_retailer_dispatch_product";
    public static final String TABLE_RETAILER_DISPATCH_PRODUCT_COPY = "bf_ishop_retailer_dispatch_product_copy";
    public static final String TABLE_RETAILER_RETURN = "bf_ishop_retailer_return";
    public static final String TABLE_RETAILER_RETURN_COPY = "bf_ishop_retailer_return_copy";
    public static final String TABLE_RETAILER_RETURN_PRODUCT = "bf_ishop_retailer_return_product";
    public static final String TABLE_RETAILER_RETURN_PRODUCT_COPY = "bf_ishop_retailer_return_product_copy";
    public static final String TABLE_DISTRIBUTOR_RETURN = "bf_ishop_distributor_return";
    public static final String TABLE_DISTRIBUTOR_RETURN_COPY = "bf_ishop_distributor_return_copy";
    public static final String TABLE_DISTRIBUTOR_RETURN_PRODUCT = "bf_ishop_distributor_return_product";
    public static final String TABLE_DISTRIBUTOR_RETURN_PRODUCT_COPY = "bf_ishop_distributor_return_product_copy";
    public static final String TABLE_DISTRIBUTOR_RETURN_REQUEST = "bf_ishop_distributor_return_request";
    public static final String TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY = "bf_ishop_distributor_return_request_copy";
    public static final String TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT =
            "bf_ishop_distributor_return_request_product";
    public static final String TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY =
            "bf_ishop_distributor_return_request_product_copy";
    public static final String TABLE_CFA_RETURN = "bf_ishop_cfa_return";
    public static final String TABLE_CFA_RETURN_COPY = "bf_ishop_cfa_return_copy";
    public static final String TABLE_CFA_RETURN_PRODUCT = "bf_ishop_cfa_return_product";
    public static final String TABLE_CFA_RETURN_PRODUCT_COPY = "bf_ishop_cfa_return_product_copy";
    public static final String TABLE_CPM_STOCK = "bf_ishop_cpm_stock";
    public static final String TABLE_CPM_STOCK_DETAILS = "bf_ishop_cpm_stock_details";
    public static final String TABLE_CUSTOMER_DETAILS = "customer_details";

    public static final String TABLE_ETORMAPPING = "etormapping";
    public static final String TABLE_RETAILER_SCANNED_IN_STICKER = "retailer_scaned_in_sticker";
    public static final String TABLE_RETAILER_SCANNED_OUT_STICKER = "retailer_scaned_out_sticker";

    public static final String TABLE_YELLOW_LABEL_DISCARD = "bf_ishop_yellow_lable_discard";
    public static final String TABLE_YELLOW_LABEL_DISCARD_DETAILS = "bf_ishop_yellow_lable_discard_details";

    public static final String TABLE_SALES_INITIATED_PRODUCT_CURRENT_LIMIT = "sales_rep_initiated_product_current_limit";

    //eVoucher
    public static final String TABLE_EVOUCHER_SCAN = "table_evoucher_scan";
    public static final String TABLE_MASTER_CONVERSION = "master_conversion";
    public static final String KEY_REDEMPTION_DETAIL_ID = "redeemption_details_id";
    public static final String KEY_SKU_COUNTRY_ID = "sku_country_id";

    public static final String KEY_CONVERSION_ID = "conversation_id";
    public static final String KEY_PRODUCT_SKU_ID_CONVERSION = "product_sku_id";
    public static final String KEY_SKU_CONVERSION_FACTOR = "sku_convesion_factor";
    public static final String KEY_BOX_CONVERSION_FACTOR = "box_conversion_factor";

    //Blocking Retailer and Distributor
    public static final String TABLE_SKU_WISE_BLOCKING = "bf_sku_wise_blocking_period_details";
    public static final String TABLE_BLOCKING_LOOKUP_VALUES = "lookup_values_config";
    public static final String KEY_INT_ID = "intId";
    public static final String KEY_PBG_ID_BLOCK = "pbg_id";
    public static final String KEY_SKU_ID = "sku_id";
    public static final String KEY_NO_OF_MONTH = "no_of_month";
    public static final String KEY_BLOCK_SCANNING_CODE = "block_scanning_code";
    public static final String KEY_BLOCK_SCANNING_BY = "block_scanning_by";

    public static final String KEY_LOOKUP_TYPE_ID = "lookuptype_id";
    public static final String KEY_LOOKUP_CODE = "varLookupCode";
    public static final String KEY_LOOKUP_VALUE = "varLookupValue";


    public static final String DTMONTH = "dtmonth";
    public static final String TOTALINSCANNED = "TotalInScanned";
    public static final String TABLE_RTORMAPPING = "rtormapping";
    public static final String TABLE_DTORMAPPING = "dtormapping";
    public static final String TABLE_PRODUCT_TYPE_NAME_COUNTRY = "product_type_name_country";
    public static final String TABLE_STICKER_DETAILS = "ishop_sticker_details";
    public static final String TABLE_STICKER_DETAILS_COPY = "ishop_sticker_details_copy";
    public static final String TABLE_MASTER_PRODUCT_SKU_COUNTRY = "product_sku_country";
    public static final String TABLE_STICKER = "ishop_sticker";
    public static final String TABLE_STICKER_COPY = "ishop_sticker_copy";
    public static final String TABLE_MENU_ACCESS = "Menu_Access";
    public static final String TABLE_POLITICAL_LEVEL = "political_level";
    public static final String TABLE_POLITICAL_DETAILS = "political_details";
    public static final String TABLE_CUSTOMER_PRODUCT_STOCK = "cpm_customer_product_stock";
    public static final String TABLE_CUSTOMER_PRODUCT_DAMAGE_STOCK = "cpm_customer_product_damage_stock";
    public static final String TABLE_SAVE_OFFLINE_LOG = "bf_ishop_save_offline_log_android_cpm";
    public static final String KEY_ID = "id";
    public static final String KEY_TOLLER_DISPATCH_ID = "toller_dispatch_id";
    public static final String KEY_CUSTOMER_FROM_ID = "customer_from_id";
    public static final String KEY_TOTAL_PRODUCT = "intTotalProduct";
    // COLUMN NAME
    public static final String KEY_customer_to_name = "customer_to_name";
    //

    /*TOdo change By Praveen */

    public static final String TABLE_ISHOP_RETAILER_RETURN = "bf_ishop_retailer_return";
    public static final String RETAILER_RETURN_ID = "retailer_return_id";
    public static final String RETAILER_RETURN_PRODUCT_ID = "retailer_return_product_id";
    public static final String TABLE_ISHOP_RETAILER_RETURN_PRODUCT = "bf_ishop_retailer_return_product";

    /**
     * Save Offline Key
     */
    public static final String KEY_START_TIME = "save_start_date_time";
    public static final String KEY_END_TIME = "save_end_date_time";
    public static final String KEY_TOTAL_RECORDS_SAVED = "total_records";
    public static final String KEY_SAVE_DONE = "save_done";
    public static final String KEY_VERSION = "version";
    public static final String KEY_IMEINO = "imei_no";

    public static final String EXTRA_STICKER_DETAIL_ID = "extra_sticker_detail_id";
    public static final String EXTRA_STICKER_ID = "extra_sticker_id";
    public static final String BASE_BTC_NO_OUT = "base_btc_no_out";
    public static final String BASE_BTC_NO_IN = "base_btc_no_in";
    public static final String BASE_QR_CODE_IN = "base_qr_code_in ";
    public static final String BASE_QR_CODE_OUT = "base_qr_code_out";
    public static final String QR_CODE_IN = "qr_code_in";
    public static final String QR_CODE_OUT = "qr_code_out";
    public static final String STICKER_DETAIL_ID = "sticker_details_id";
    public static final String MAPPED_ON = "mapped_on";
    public static final String CREATE_BY_USER = "created_by_user";
    public static final String CREATE_ON = "created_on";
    public static final String SYNC_CODE = "sync_code";
    public static final String SYNC_FLAG = "sync_flag";
    public static final String SYNC_DATE = "sync_date";

    //CREATE_TABLE_DEVICE_TOKEN
    public static final String TABLE_DEVICE_TOKEN = "table_device_token";
    public static final String KEY_DEVICE_TOKEN = "device_token";
    public static final String KEY_USER_ID = "user_id";

    public static final String KEY_OUT_POINT_CALCULATE = "out_point_calculate";
    public static final String KEY_RECEIVE_SCAN_TYPE = "received_scan_type";

    //cpm_customer_product_stock
    public static final String KEY_DISPATCH_DATE_TIME = "dispatchdatetime";
    public static final String KEY_STDONO = "doNo";
    public static final String KEY_new_customer_type = "new_customer_type";
    public static final String KEY_customer_to_phone = "customer_to_phone";
    public static final String KEY_CUSTOMER_TO_ID = "customer_to_id";
    public static final String KEY_DISPATCH_DATE = "dispatch_date";
    public static final String KEY_DOCUMENT_NO = "document_no";
    public static final String KEY_COUNTRY_ID = "country_id";
    public static final String KEY_CREATED_BY_USER = "created_by_user";
    public static final String KEY_MODIFIED_BY_USER = "modified_by_user";
    public static final String KEY_STATUS = "status";
    public static final String KEY_CREATE_ON = "created_on";
    public static final String KEY_CREATE_BY = "created_by";
    public static final String KEY_MODIFIED_ON = "modified_on";
    public static final String KEY_SYNC_CODE = "sync_code";
    public static final String KEY_SYNC_FLAG = "sync_flag";
    public static final String KEY_SYNC_DATE = "sync_date";
    public static final String KEY_ANDROID_SYNC = "android_sync";
    public static final String KEY_PALLET_DETAIL_ID = "pallet_details_id";
    public static final String KEY_isDispatch = "isDispatch";
    public static final String KEY_SYNC_USER = "sync_by_user";
    public static final String KEY_RECEIVED = "received";
    public static final String KEY_RECEIVED_DATE = "received_date";
    public static final String KEY_READ = "isRead";
    public static final String KEY_IS_DISPATCH = "isDispatch";
    public static final String KEY_READ_DATE = "read_date";
    public static final String KEY_TOLLER_DISPATCH_PRODUCT_ID = "toller_dispatch_product_id";
    public static final String KEY_PRODUCT_SKU_COUNTRY_ID = "product_sku_country_id";
    public static final String KEY_STICKER_ID = "sticker_id";
    public static final String KEY_BATCH_NO = "batch_no";
    public static final String KEY_BATCH_ID = "batch_id";
    public static final String KEY_QUANTITY = "quantity";
    public static final String KEY_AMOUNT = "amount";
    public static final String KEY_UNIT = "unit";
    public static final String KEY_QTY_KGL = "qty_kgl";
    public static final String KEY_CFA_DISPATCH_ID = "cfa_dispatch_id";
    public static final String KEY_SAP_ID = "sap_id";
    public static final String KEY_DISPATCH_TYPE = "dispatch_type";
    public static final String KEY_DO_STO_NO = "do_sto_no";
    public static final String KEY_DOC_NO = "doc_no";
    public static final String KEY_CFA_DISPATCH_PRODUCT_ID = "cfa_dispatch_product_id";
    public static final String KEY_PRODUCT_SKU_ID = "product_sku_id";
    public static final String KEY_STICKER_DETAILS_ID = "sticker_details_id";
    public static final String KEY_BTC_NO = "btc_no";
    public static final String KEY_BTC_NO_OUT = "btc_no_out";
    public static final String KEY_IS_VALID = "is_valid";
    public static final String KEY_DISTRIBUTOR_DISPATCH_ID = "distributor_dispatch_id";
    public static final String KEY_CUSTOMER_TYPE_COUNTRY_ID = "customer_type_country_id";
    public static final String KEY_Customer_type_name_country = "Customer_type_name_country";
    public static final String KEY_customer_level = "customer_level";
    public static final String KEY_customer_type_name = "customer_type_name";
    public static final String KEY_IS_NEW_CUSTOMER = "is_new_customer";
    public static final String KEY_DISTRIBUTOR_DISPATCH_PRODUCT_ID = "distributor_dispatch_product_id";
    public static final String KEY_CUSTOMER_ID = "customer_id";
    public static final String KEY_CUSTOMER_NAME = "customer_name";
    public static final String KEY_CUSTOMER_TYPE_COUNTY_ID = "customer_type_country_id";
    public static final String KEY_MOBILE_NO = "mobile_no";
    public static final String KEY_PRIMARY_MOBILE_NO = "primary_mobile_no";
    public static final String KEY_RETAILER_DISPATCH_ID = "retailer_dispatch_id";
    public static final String KEY_RETAILER_DISPATCH_PRODUCT_ID = "retailer_dispatch_product_id";
    public static final String KEY_BTC_TYPE = "btc_type";
    public static final String KEY_RETAILER_RETURN_ID = "retailer_return_id";
    public static final String KEY_RETURN_DATE = "return_date";
    public static final String KEY_RETAILER_RETURN_PRODUCT_ID = "retailer_return_product_id";
    public static final String KEY_DISTRIBUTOR_RETURN_ID = "distributor_return_id";
    public static final String KEY_DISTRIBUTOR_RETURN_PRODUCT_ID = "distributor_return_product_id";
    public static final String KEY_DISTRIBUTOR_RETURN_REQUEST_ID = "distributor_return_request_id";
    public static final String KEY_RETURN_REQUEST_DATE = "return_request_date";
    public static final String KEY_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_ID =
            "distributor_return_request_product_id";
    public static final String KEY_CFA_RETURN_ID = "cfa_return_id";
    public static final String KEY_CFA_RETURN_PRODUCT_ID = "cfa_return_product_id";
    public static final String KEY_CPM_STOCK_ID = "cpm_stock_id";
    public static final String KEY_STOCK_DATE = "stock_date";
    public static final String KEY_CPM_STOCK_DETAILS_ID = "cpm_stock_details_id";
    public static final String KEY_TRANSACTIONS_TYPE = "tran_type";
    public static final String KEY_TRANSACTIONS_DATE = "tran_date";
    public static final String KEY_ENTRY_FROM = "entry_from";
    public static final String KEY_EMAIL = "email";
    public static final String KEY_USER_CODE = "user_code";
    public static final String KEY_BUSSINESS_CODE = "bussiness_code";
    public static final String KEY_DISPLAY_NAME = "display_name";
    public static final String KEY_CUSTOMER_TYPE_COUNTRY_CODE = "customer_type_country_code";
    public static final String KEY_CUSTOMER_TYPE_COUNTRY_NAME = "customer_type_country_name";
    public static final String KEY_CUSTOMER_TYPE_REGIONAL_ID = "customer_type_regional_id";
    public static final String KEY_CUSTOMER_TYPE_REGIONAL_NAME = "customer_type_regional_name";
    public static final String KEY_CUSTOMER_TYPE_REGIONAL_CODE = "customer_type_regional_code";
    public static final String KEY_CUSTOMER_TYPE_REGIONAL_LEVEL = "customer_regional_level";
    public static final String KEY_EMPLOYEE_TYPE_REGIONAL_LEVEL = "employee_regional_level";
    public static final String KEY_PRODUCT_COUNTRY_ID = "product_country_id";
    public static final String KEY_PRODUCT_REGIONAL_ID = "product_regional_id";
    public static final String KEY_PRODUCT_COUNTRY_NAME = "product_country_name";
    public static final String KEY_PRODUCT_REGIONAL_CODE = "product_regional_code";
    public static final String KEY_DESCRIPTION = "Description";
    public static final String KEY_DELETED = "deleted";
    public static final String KEY_BTC_NO_IN = "btc_no_in";
    public static final String KEY_QR_CODE_IN = "qr_code_in";
    public static final String KEY_QR_CODE_OUT = "qr_code_out";
    public static final String KEY_qr_code = "qr_code";
    public static final String KEY_STICKER_NO = "sticker_no";
    public static final String KEY_IS_BUFFER = "isBuffer";
    public static final String KEY_PRODUCT_SKU_NAME = "product_sku_name";
    public static final String KEY_PBG_ID = "PBG_ID";
    public static final String KEY_PRODUCT_SKU_CODE = "product_sku_code";
    public static final String KEY_REF_ID = "ref_Id";
    public static final String KEY_SYSTEM_CODE = "system_code";
    public static final String KEY_TOLLER_CODE = "toller_code";
    public static final String KEY_PRODUCTION_DATE = "production_date";
    public static final String KEY_PBG_COUNTRY_ID = "PBG_Country_Id";
    public static final String KEY_MFG_DATE = "mfg_date";
    public static final String KEY_EXPIRE_DATE = "expire_date";
    public static final String KEY_BUFFER = "buffer";
    public static final String KEY_DRAFT = "draft";
    public static final String KEY_DRAFT_DATE = "draft_date";
    public static final String KEY_DRAFT_REASON = "draft_reason";
    public static final String KEY_ORDER = "orderId";
    public static final String KEY_ALIAS = "alias";
    public static final String KEY_MENU_ID = "menu_id";
    public static final String KEY_TITLE = "title";
    public static final String KEY_POLITICAL_GEOGRAPHY_COUNTRY_LEVEL_ID =
            "political_geography_countrylevel_id";
    public static final String KEY_LEVEL_NAME = "level_name";
    public static final String KEY_LEVEL = "level";
    public static final String KEY_POLITICAL_GEO_ID = "political_geo_id";
    public static final String KEY_PARENT_GEO_ID = "parent_geo_id";
    public static final String KEY_POLITICAL_GEOGRAPHY_CODE = "political_geography_code";
    public static final String KEY_POLITICAL_GEOGRAPHY_NAME = "political_geography_name";
    public static final String KEY_MODIFICATION_BY_USER = "modified_by_user";
    public static final String KEY_REGIONAL_LEVEL = "regional_level";
    public static final String KEY_GEO_LEVEL_ID = "geo_level_id";
    public static final String KEY_CUSTOMER_PRODUCT_STOCK_ID = "cpm_customer_product_stock_id";
    public static final String KEY_CUSTOMER_PRODUCT_DAMAGE_STOCK_ID = "cpm_customer_product_damage_stock_id";
    public static final String KEY_PRODUCT_STOCK_KGL = "current_stock_kgl";
    public static final String KEY_CURRENT_LIMIT = "current_limit";

    public static final String Political_Geo_4 = "political_geo_level_4";
    public static final String RECIEVE_Days = "intReceiveDays";
    public static final String RECIEVE_POPUP = "charReceivePopUp";
    public static final String CUSTOMER_SYNC_DISABLE = "chr_cust_sync_enable";
    public static final String KEY_PRODUCT_STOCK_BOX = "current_stock_box";
    public static final String LOGIN_MASTER = "login";
    public static final String VAR_USERNAME = "var_username";
    public static final String VAR_PASSWORD = "var_password";
    // Database creation sql statement
    public static final String VAR_PERSONNAME = "var_personname";
    public static final String KEY_COUNTRY_CODE = "country_code";
    public static final String FK_PERSONGICODE = "fk_personGlcode";
    public static final String FK_EMPGLCODE = "fk_empGlcode";
    public static final String VAR_MOBILENUMBER = "var_mobilenumber";
    public static final String VAR_LASTSYNCTIME = "var_lastsynctime";
    public static final String VAR_ClIENTNAME = "var_clientname";
    public static final String IS_AUTHORISED = "is_authorised";
    public static final String IS_SMSON = "is_smson";
    public static final String IMEI = "imei";
    public static final String KEY_PARENT_ID = "parent_id";
    public static final String KEY_PARENT_USER_ID = "parent_user_id";
    public static final String INTGLCODE = "intGlCode";
    // public static final String KEY_POLITICAL_GEO_ID = "political_geo_id";
    public static final String KEY_political_geography_countrylevel_id = "political_geography_countrylevel_id";
    public static final String KEY_political_regional_level = "political_regional_level";
    public static final String DATABASE_NAME = "Re_CPM";
    //New Table
    public static final String TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED = "bf_ishop_distributor_received";
    public static final String TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_COPY = "bf_ishop_distributor_received_copy";
    public static final String TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT =
            "bf_ishop_distributor_received_product";
    public static final String TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT_COPY =
            "bf_ishop_distributor_received_product_copy";
    public static final String TABLE_BF_ISHOP_RETAILER_RECEIVED = "bf_ishop_retailer_received";
    public static final String TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY = "bf_ishop_retailer_received_copy";
    public static final String TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT = "bf_ishop_retailer_received_product";
    public static final String TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT_COPY = "bf_ishop_retailer_received_product_copy";
    public static final String DISTRIBUTOR_RECEIVED_ID = "distributor_received_id";
    public static final String RETAILER_RECEIVED_ID = "retailer_received_id";
    public static final String IS_NEW_CUSTOMER = "is_new_customer";
    public static final String DISPATCH_date = "dispatch_date";
    public static final String SYNC_BY_USER = "sync_by_user";
    public static final String DISTRIBUTOR_RECEIVED_PRODUCT_ID = "distributor_received_product_id";
    public static final String RETAILER_RECEIVED_PRODUCT_ID = "retailer_received_product_id";
    public static final String BTC_NO_OUT = "btc_no_out";
    //dispatch_scan_type  Received  Returned
    public static final String USER_CONFIGURATION_MST = "user_configuration_mst";
    public static final String DISPATCH_SCAN_TYPE = "dispatch_scan_type";
    public static final String RECEIVED = "received";
    public static final String RETURNED = "returned";
    public static final String IS_DISPATCH_TYPE = "is_dispatch_type";
    public static final String ID = "IDS";
    public static final String TABLE_Last_Sync_Date_Time = "Last_Sync_Date_Time";
    /* TODO Change By Praveen */
    public static final String TABLE_EXTRA_PALLET_STICKER_DETAIL = "bf_ishop_extra_pallet_sticker_details";
    public static final String TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY = "bf_ishop_extra_pallet_sticker_details_copy";
    public static final String EXTRA_PALLET_STICKER_DETAIL_ID = "extra_pallet_sticker_detail_id";
    public static final String BASE_PALLET_SERIAL_NO = "base_pallet_serial_no";
    public static final String BASE_PALLET_QR_CODE = "base_pallet_qr_code";
    public static final String PALLET_SERIAL_NO = "pallet_serial_no";
    public static final String PALLET_QR_CODE = "pallet_qr_code";


    /* WAREHOUSE_DISPATCH_SCM)BY_JAY*/
    public static final String TABLE_DISPATCH_WAREHOUSE = "bf_scm_cpm_integration_data";
    public static final String TABLE_DISPATCH_WAREHOUSE_COPY = "bf_scm_cpm_integration_data_copy";
    public static final String SCM_CPM_ID = "scm_cpm_id";
    public static final String DO_STO_NO = "do_sto_no";
    public static final String FROM_USER_ID = "from_user_id";
    public static final String TO_USER_ID = "to_user_id";
    public static final String TRUCK_NO = "truck_no";
    public static final String SHIPMENT_STATUS = "shipment_status";
    public static final String ARTICLE_ID = "article_id";
    public static final String BATCH_NO = "batch_no";
    public static final String DEC_QTY = "dec_qty";
    public static final String DEC_QTY_KGL = "dec_qty_kgl";
    public static final String DELETED = "deleted";
    public static final String CREATED_BY_USER = "created_by_user";
    public static final String CREATED_ON = "created_on";
    public static final String MODIFIED_ON = "modified_on";


    public static final String TABLE_EMPLOYEE_DETAILS = "employee_details";
    public static final String TABLE_POLITICAL_DETAILS_EMP = "political_detail_emp";
    public static final String TABLE_ISHOP_SAMPLE_DISPATCH = "bf_ishop_sample_dispatch";
    public static final String TABLE_ISHOP_SAMPLE_DISPATCH_COPY = "bf_ishop_sample_dispatch_copy";
    public static final String TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT = "bf_ishop_sample_dispatch_product";
    public static final String TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT_COPY = "bf_ishop_sample_dispatch_product_copy";


    public static final String COL_SAMPLE_DISPATCH_ID = "sample_dispatch_id";
    public static final String COL_SAMPLE_DISPATCH_PRODUCT_ID = "sample_dispatch_product_id";


    //B2C Config
    public static final String B2C_CONFIG_TABLE = "b2c_config";
    public static final String B2C_LOG_DETAILS = "bf_b2c_log_details ";

    public static final String KEY_IS_B2C = "is_b2c";
    public static final String KEY_CONFIG_ID = "config_id";
    public static final String KEY_CONFIG_CODE = "config_code";
    public static final String KEY_TENANT = "tenant";
    public static final String KEY_POLICY = "policy";
    public static final String KEY_CLIENT_ID = "client_id";
    public static final String KEY_SCOPE = "scope";
    public static final String KEY_CLIENT_SECRET_KEY = "client_secret_key";
    public static final String KEY_PLATFORM = "platform";
    public static final String KEY_METHOD = "method";
    public static final String KEY_CERTIFICATE_FILE = "certificate_file";
    public static final String KEY_FILE = "key_file";
    public static final String KEY_APPLICATION_TYPE = "application_type";

    public static final String KEY_LOG_ID = "log_id";
    public static final String KEY_REQUEST_URL = "request_url";
    public static final String KEY_REQUEST_PARAM = "request_param";
    public static final String KEY_REQUEST_MESSAGE = "request_message";
    public static final String KEY_HEADER = "header";
    public static final String KEY_RESPONSE = "response";
    public static final String KEY_CODE = "code";
    public static final String KEY_RESPONSE_STATUS = "response_status";
    public static final String KEY_PLATFORM_TYPE = "platform";
    public static final String KEY_START_TIME_LOG = "start_date_time";
    public static final String KEY_END_TIME__LOG = "end_date_time";

    public static final String B2C_LOGIN = "b2c_login";

    public static final String KEY_PHONE_NUMBER = "phoneNumber";
    public static final String KEY_ACCESSTOKEN = "accesstoken";
    public static final String KEY_ID_TOKEN = "idToken";
    public static final String KEY_REFRESH_TOKEN = "refreshToken";
    public static final String KEY_COUNTRY_CODE_B2C = "country_code";
    public static final String KEY_TOKEN_EXPIRY = "token_expiry_date";
    public static final String KEY_SUB = "sub";

    public static final String AUTO_SYNC = "autosync";
    public static final String AUTO_SYNC_DAY = "autosyncday";


    public static final String CREATE_TABLE_EXTRA_PALLET_STICKER_DETAIL = "CREATE TABLE IF NOT EXISTS " +
            TABLE_EXTRA_PALLET_STICKER_DETAIL +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            EXTRA_PALLET_STICKER_DETAIL_ID + " int," +
            EXTRA_STICKER_ID + " int," +
            BASE_PALLET_SERIAL_NO + " TEXT," +
            BASE_PALLET_QR_CODE + " TEXT," +
            PALLET_SERIAL_NO + " TEXT," +
            PALLET_QR_CODE + " TEXT," +
            KEY_PALLET_DETAIL_ID + " int," +
            KEY_CREATED_BY_USER + " int," +
            CREATE_ON + " TEXT," +
            SYNC_CODE + " TEXT," +
            SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            SYNC_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            KEY_ANDROID_SYNC + " TEXT)";


    public static final String CREATE_TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY = "CREATE TABLE IF NOT EXISTS " +
            TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            EXTRA_PALLET_STICKER_DETAIL_ID + " int," +
            EXTRA_STICKER_ID + " int," +
            BASE_PALLET_SERIAL_NO + " TEXT," +
            BASE_PALLET_QR_CODE + " TEXT," +
            PALLET_SERIAL_NO + " TEXT," +
            PALLET_QR_CODE + " TEXT," +
            KEY_PALLET_DETAIL_ID + " int," +
            KEY_CREATED_BY_USER + " int," +
            CREATE_ON + " TEXT," +
            SYNC_CODE + " TEXT," +
            SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            SYNC_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            KEY_ANDROID_SYNC + " TEXT)";

    public static final String CREATE_TABLE_Last_Sync_Date_Time = "CREATE TABLE IF NOT EXISTS " +
            TABLE_Last_Sync_Date_Time + "(Last_Sync_Date_Time TEXT, Last_Sync_Date_Time_Trn_Get TEXT)";

    public static final String CREATE_TABLE_USER_CONFIGURATION_MST = "CREATE TABLE IF NOT EXISTS " +
            USER_CONFIGURATION_MST +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            ID + " TEXT," +
            DISPATCH_SCAN_TYPE + " TEXT," +
            RECEIVED + " TEXT," +
            RETURNED + " TEXT," +
            Political_Geo_4 + " TEXT," +
            RECIEVE_Days + " TEXT," +
            RECIEVE_POPUP + " TEXT," +
            CUSTOMER_SYNC_DISABLE + " TEXT," +
            INT_SYNC_MINUTES + " TEXT," +
            INT_SCAN_SCREEN + " TEXT," +
            CHAR_PALLATE_ENABLE + " TEXT," +
            FTP_HOST + " TEXT," +
            FTP_PORT + " TEXT," +
            FTP_USERNAME + " TEXT," +
            FTP_PASSWORD + " TEXT," +
            INT_SYNC_ALERT_MINUTES + " TEXT," +
            INT_SCAN_ALERT_MINUTES + " TEXT," +
            CHR_SCM_CPM + " TEXT DEFAULT '' ," +
            INT_SALES_RET_LIMIT + " TEXT," +
            IS_SYNC_POPUP + " TEXT," +
            IS_EXPIRE_ENABLE + " TEXT," +
            INT_MINIMUM_MINS + " TEXT DEFAULT '0'," +
            INT_MAXIMUM_MINS + " TEXT DEFAULT '0'," +
            CHR_SCAN_TYPE_RADIO_BTN + " TEXT DEFAULT '')";

    public static final String TABLE_SALES_REP_INITIATED_PRODUCT = "bf_ishop_sales_rep_initiated_product";
    /*  fk_PBG_Country_id int,
   fk_Sku_Country_id int,*/
    public static final String FK_PBG_COUNTRY_ID = "fk_PBG_Country_id";
    public static final String FK_SKU_COUNTRY_ID = "fk_Sku_Country_id";
    public static final String DECQTY = "decQty";
    public static final String VARREMARKS = "varRemarks";
    public static final String SCAN_COUNT = "scan_count";
    public static final String SRIP_ID = "srip_id";
    // ,
    public static final String CREATED_BY_NAME = "created_by_name";
    public static final String MODIFIED_BY_NAME = "modifed_by_name";
    public static final String FROM_CUSTOMER_ID = "from_customer_id";
    public static final String TO_CUSTOMER_ID = "to_customer_id";
    public static final String FROM_CUSTOMER_LEVEL = "from_customer_level";
    public static final String TO_CUSTOMER_LEVEL = "to_customer_level";

    public static final String TABLE_CTOCMAPPING = "ctocmapping";
    public static final String TABLE_CustomerType_Details = "CustomerType_Details";

    public static final String TABLE_CTOEMAPPING = "ctoemapping";
    public static final String EMPLOYEE_ID = "employee_id";
    public static final String CUSTOMER_ID = "customer_id";
    public static final String USER_CODE = "user_code";
    public static final String DISPLAY_NAME = "display_name";
    public static final String EMAIL = "email";
    public static final String PRIMARY_MOBILE_NO = "primary_mobile_no";
    public static final String KEY_PRIMARY_SERIALNO = "primary_serialno";
    public static final String KEY_BARCODENO = "barcodeNo";
    public static final String KEY_CUSTOMERLEVEL = "customerLevel";
    public static final String KEY_LOGGEDINID = "loggedInId";
    public static final String KEY_ISVALID = "isValid";
    public static final String KEY_USERID = "userID";
    public static final String KEY_SUBCODE = "subCode";
    public static final String KEY_REMAINING_STOCK_BOX = "remaining_stock_box";
    public static final String KEY_NEW_REMAINING_STOCK_BOX = "new_remaining_stock_box";
    /* "scheme_id": "58",
      "": "ONE",
      "": "SCHEME_ONE",
      "": "2016-01-01",
      "": "2018-12-01",
      "": "58249843",
      "": "ABATE 1 SG,A1X25 KG,UNSPEZ.",
      "": "4.00"*/
    public static final String KEY_SCHEME_ID = "scheme_id";
    public static final String KEY_SCHEME_CODE = "scheme_code";
    public static final String KEY_SCHEME_NAME = "scheme_name";
    public static final String KEY_FROM_MONTH = "from_month";
    public static final String KEY_TO_MONTH = "to_month";
    public static final String KEY_VALUE_PER_POINT = "value_per_point";


    public static final String KEY_REJECT = "reject";
    public static final String KEY_REJECT_DATE = "rejected_date";
    public static final String KEY_REJECT_REASON = "rejected_comment";
    public static final String KEY_REJECT_ID = "rejected_reason";
    public static final String KEY_SCAN_TYPE = "scan_type";


    //For Video
    public static final String TABLE_HELP_VIDEO_DETAIL = "bf_master_cpm_help_video_details";
    public static final String VIDEO_TYPE_ID = "video_type_id";
    public static final String VIDEO_MENU_ID = "video_menu_id";
    public static final String VIDEO_MENU_NAME = "video_menu_name";
    public static final String ROLE_ID_IN_VIDEO = "role_id";
    public static final String VIDEO_FILE_NAME = "file_name";
    public static final String VIDEO_LOCAL_PATH = "video_local_path";
    public static final String VIDEO_UPLOAD_TYPE = "upload_type";
    public static final String VIDEO_CUSTOMER_ID = "customer_id";
    public static final String IS_DOWNLOADED = "isDownload";
    public static final String VIDEO_TYPE_DETAIL_ID = "video_type_details_id";
    public static final String KEY_IMEI_NO = "imeino";

    //    For Rejection
    public static final String TABLE_MASTER_REASON = "master_reason";
    public static final String KEY_REASON_ID = "reason_id";
    public static final String KEY_REASON_NAME = "reason_name";
    public static final String KEY_REASON_CODE = "reason_code";
    public static final String KEY_USED_FOR_ID = "used_for_id";
    public static final String KEY_USED_FOR_CODE = "used_for_code";



    public static final String TABLE_ISHOP_PALLET_DETAILS="bf_ishop_pallet_details";
    public static final String TABLE_ISHOP_PALLET_DETAILS_COPY="bf_ishop_pallet_details_copy";

    //Transaction Errro Log Table And Column
    public static final String TABLE_TRANSACTION_ERROR_LOG = "bf_ishop_transaction_error_log";
    public static final String KEY_ERROR_LOG_ID = "error_log_id";
    public static final String KEY_PAGE_NAME = "page_name";
    public static final String KEY_METHOD_NAME = "method_name";
    public static final String KEY_ERROR_MSG = "error_message";
    public static final String KEY_STACKTRACE = "stack_trace";
    public static final String KEY_MODULE_NAME = "module_name";
    public static final String KEY_SOURCE_SYSTEM = "source_system";
    public static final String KEY_ERROR_FORM = "error_form";
    public static final String KEY_EXTRA1 = "extra1";
    public static final String KEY_EXTRA2 = "extra2";
    public static final String KEY_ERROR_CODE = "error_code";
    public static final String KEY_ERROR_DATE = "error_date";
    public static final String KEY_SYNC_PROCESS_ID = "sync_process_id";

    /*Todo change by chandan */

    public static final String KEY_YELLOW_LABEL_DISCARD_ID = "yellow_label_discard_id";
    public static final String KEY_DISCARD_DATE = "discard_date";
    public static final String KEY_IS_DISCARD = "isDiscard";

    public static final String KEY_YELLOW_LABEL_DISCARD_PRODUCT_ID = "yellow_lable_discard_product_id";
    private static final int DATABASE_VERSION = 39;// Auto Sync Dist

    private static final String CREATE_TABLE_DISPATCH_BATCHWISE_STOCK_CALCULATE = "CREATE TABLE IF NOT EXISTS " +
            TABLE_DISPATCH_BATCHWISE_STOCK_CALCULATE + "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CUSTOMER_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_PRODUCT_STOCK_BOX + " TEXT,"
            + KEY_BATCH_NO + " TEXT,"
            + KEY_REMAINING_STOCK_BOX + " TEXT,"
            + KEY_NEW_REMAINING_STOCK_BOX + " TEXT" + ")";
    private static final String CREATE_TABLE_SCANNEDSTICKERS = "CREATE TABLE IF NOT EXISTS " +
            TABLE_SCANNEDSTICKERS + "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_PRIMARY_SERIALNO + " INTEGER," +
            KEY_BARCODENO + " TEXT," +
            KEY_CUSTOMERLEVEL + " TEXT," +
            KEY_LOGGEDINID + " TEXT," +
            KEY_USERID + " TEXT," +
            KEY_SUBCODE + " TEXT," +
            KEY_ISVALID + " INTEGER," +
            KEY_SCAN_TYPE + " TEXT," +
            KEY_STICKER_DETAILS_ID + " INTEGER DEFAULT 0," +
            KEY_BATCH_NO + " TEXT," +
            KEY_PRODUCT_SKU_COUNTRY_ID + " TEXT," +
            Database_Column.KEY_PALLET_DETAIL_ID + " INTEGER DEFAULT 0," +
            Database_Column.KEY_IS_PALLET + " INTEGER DEFAULT 0," +
            Database_Column.KEY_SHOW_IN_LIST + " INTEGER DEFAULT 1" + ")";

    private static final String CREATE_TABLE_CHECK_MAX_DATE = "CREATE TABLE IF NOT EXISTS " +
            TABLE_CHECK_MAX_DATE + "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_STICKER_DETAILS_ID + " TEXT," +
            KEY_BARCODENO + " TEXT," +
            DIST_DISPATCH_MAX_DATE + " TEXT," +
            DIST_RETURN_REQUEST_MAX_DATE + " TEXT," +
            DIST_DAMAGE_MAX_DATE + " TEXT," +
            DIST_RET_RETURN_MAX_DATE + " TEXT," +
            CFA_DISPATCH_MAX_DATE + " TEXT" + ")";

    private static final String CREATE_TABLE_TOLLER_DISPATCH = "CREATE TABLE IF NOT EXISTS " +
            TABLE_TOLLER_DISPATCH +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_TOLLER_DISPATCH_ID + " INTEGER," +
            KEY_CUSTOMER_FROM_ID + " TEXT," +
            KEY_CUSTOMER_TO_ID + " TEXT," +
            KEY_DISPATCH_DATE + " TEXT," +
            KEY_DOCUMENT_NO + " TEXT," +
            KEY_COUNTRY_ID + " TEXT," +
            KEY_CREATED_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT," +
            KEY_STATUS + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            KEY_SYNC_USER + " TEXT," +
            KEY_RECEIVED + " TEXT," +
            KEY_READ + " TEXT," +
            KEY_READ_DATE + " TEXT," +
            KEY_RECEIVED_DATE + " TEXT," +
            KEY_REJECT + " TEXT," +
            KEY_REJECT_DATE + " TEXT," +
            KEY_REJECT_REASON + " TEXT)";

    private static final String CREATE_TABLE_TOLLER_DISPATCH_COPY = "CREATE TABLE IF NOT EXISTS " +
            TABLE_TOLLER_DISPATCH_COPY +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_TOLLER_DISPATCH_ID + " INTEGER," +
            KEY_CUSTOMER_FROM_ID + " TEXT," +
            KEY_CUSTOMER_TO_ID + " TEXT," +
            KEY_DISPATCH_DATE + " TEXT," +
            KEY_DOCUMENT_NO + " TEXT," +
            KEY_COUNTRY_ID + " TEXT," +
            KEY_CREATED_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT," +
            KEY_STATUS + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            KEY_SYNC_USER + " TEXT," +
            KEY_RECEIVED + " TEXT," +
            KEY_READ + " TEXT," +
            KEY_READ_DATE + " TEXT," +
            KEY_RECEIVED_DATE + " TEXT," +
            KEY_REJECT + " TEXT," +
            KEY_REJECT_DATE + " TEXT," +
            KEY_REJECT_REASON + " TEXT)";

    private static final String CREATE_TABLE_TOLLER_DISPATCH_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_TOLLER_DISPATCH_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_TOLLER_DISPATCH_PRODUCT_ID + " INTEGER,"
            + KEY_TOLLER_DISPATCH_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_COUNTRY_ID + " INTEGER,"
            + KEY_STICKER_ID + " INTEGER,"
            + KEY_BATCH_NO + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT," +
            KEY_READ + " TEXT," +
            KEY_READ_DATE + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT ," +
            KEY_SYNC_DATE + " TEXT," +
            KEY_SYNC_USER + " TEXT)";
//    private static final String CREATE_TABLE_CFA_DISPATCH = "CREATE TABLE IF NOT EXISTS "
//            + TABLE_CFA_DISPATCH
//            + "("
//            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
//            + KEY_CFA_DISPATCH_ID + " INTEGER,"
//            + KEY_CUSTOMER_FROM_ID + " TEXT,"
//            + KEY_CUSTOMER_TO_ID + " TEXT,"
//            + KEY_SAP_ID + " TEXT,"
//            + KEY_DISPATCH_TYPE + " TEXT,"
//            + KEY_DO_STO_NO + " TEXT,"
//            + KEY_DISPATCH_DATE + " TEXT,"
//            + KEY_RECEIVED + " TEXT,"
//            + KEY_RECEIVED_DATE + " TEXT,"
//            + KEY_COUNTRY_ID + " TEXT,"
//            + KEY_CREATED_BY_USER + " TEXT,"
//            + KEY_MODIFIED_BY_USER + " TEXT,"
//            + KEY_STATUS + " TEXT,"
//            + KEY_CREATE_ON + " TEXT,"
//            + KEY_MODIFIED_ON + " TEXT,"
//            + KEY_SYNC_CODE + " TEXT,"
//            + KEY_SYNC_FLAG + " TEXT ,"
//            + KEY_SYNC_DATE + " TEXT,"
//            + KEY_READ + " TEXT,"
//            + KEY_READ_DATE + " TEXT,"
//            + KEY_IS_DISPATCH + " TEXT,"
//            + KEY_SYNC_USER + " TEXT)";


    /**
     * Added By Chandan For Database Version to 8
     */
    private static final String CREATE_TABLE_CFA_DISPATCH = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_DISPATCH
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CFA_DISPATCH_ID + " INTEGER,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_SAP_ID + " TEXT,"
            + KEY_DISPATCH_TYPE + " TEXT,"
            + KEY_DO_STO_NO + " TEXT,"
            + KEY_DISPATCH_DATE + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_READ + " TEXT,"
            + KEY_READ_DATE + " TEXT,"
            + KEY_IS_DISPATCH + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_REJECT + " TEXT,"
            + KEY_REJECT_DATE + " TEXT,"
            + KEY_REJECT_REASON + " TEXT,"
            + KEY_REJECT_ID + " TEXT,"
            + IS_DISPATCH_TYPE + " INTEGER DEFAULT 0)";

    private static final String CREATE_TABLE_CFA_DISPATCH_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_DISPATCH_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CFA_DISPATCH_ID + " INTEGER,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_SAP_ID + " TEXT,"
            + KEY_DISPATCH_TYPE + " TEXT,"
            + KEY_DO_STO_NO + " TEXT,"
            + KEY_DISPATCH_DATE + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_READ + " TEXT,"
            + KEY_READ_DATE + " TEXT,"
            + KEY_IS_DISPATCH + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_REJECT + " TEXT,"
            + KEY_REJECT_DATE + " TEXT,"
            + KEY_REJECT_REASON + " TEXT,"
            + KEY_REJECT_ID + " TEXT,"
            + IS_DISPATCH_TYPE + " INTEGER DEFAULT 0)";

    private static final String CREATE_TABLE_CFA_DISPATCH_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_DISPATCH_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CFA_DISPATCH_PRODUCT_ID + " INTEGER,"
            + KEY_CFA_DISPATCH_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_ID + " INTEGER,"
            + KEY_STICKER_DETAILS_ID + " INTEGER,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + DISPATCH_SCAN_TYPE + " TEXT )";

    private static final String CREATE_TABLE_CFA_DISPATCH_PRODUCT_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_DISPATCH_PRODUCT_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CFA_DISPATCH_PRODUCT_ID + " INTEGER,"
            + KEY_CFA_DISPATCH_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_ID + " INTEGER,"
            + KEY_STICKER_DETAILS_ID + " INTEGER,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + DISPATCH_SCAN_TYPE + " TEXT )";

    private static final String CREATE_TABLE_DISTRIBUTOR_DISPATCH = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_DISPATCH
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_DISPATCH_ID + " INTEGER,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_IS_NEW_CUSTOMER + " TEXT,"
            + KEY_DISPATCH_DATE + " TEXT,"
            + KEY_customer_to_name + " TEXT,"
            + KEY_customer_to_phone + " TEXT,"
            + KEY_new_customer_type + " TEXT,"
           /* + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"*/
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_READ + " TEXT,"
            + KEY_READ_DATE + " TEXT,"
            + KEY_IS_DISPATCH + " TEXT ,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String CREATE_TABLE_DISTRIBUTOR_DISPATCH_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_DISPATCH_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_DISPATCH_ID + " INTEGER,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_IS_NEW_CUSTOMER + " TEXT,"
            + KEY_DISPATCH_DATE + " TEXT,"
            + KEY_customer_to_name + " TEXT,"
            + KEY_customer_to_phone + " TEXT,"
            + KEY_new_customer_type + " TEXT,"
           /* + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"*/
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_READ + " TEXT,"
            + KEY_READ_DATE + " TEXT,"
            + KEY_IS_DISPATCH + " TEXT ,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String CREATE_TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_DISPATCH_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_DISPATCH_PRODUCT_ID + " INTEGER,"
            + KEY_DISTRIBUTOR_DISPATCH_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_ID + " INTEGER,"
            + KEY_STICKER_DETAILS_ID + " INTEGER,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + DISPATCH_SCAN_TYPE + " TEXT,"
            + KEY_BTC_TYPE + " TEXT)";
    private static final String CREATE_TABLE_NEW_CUSTOMER = "CREATE TABLE IF NOT EXISTS "
            + TABLE_NEW_CUSTOMER
            + "("
            + KEY_CUSTOMER_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CUSTOMER_NAME + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTY_ID + " TEXT,"
            + KEY_MOBILE_NO + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";
    private static final String CREATE_TABLE_RETAILER_DISPATCH = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_DISPATCH
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_RETAILER_DISPATCH_ID + " INTEGER,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_IS_NEW_CUSTOMER + " TEXT,"
            + KEY_DISPATCH_DATE + " TEXT,"
            /*+ KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"*/
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_READ + " TEXT,"
            + KEY_customer_to_name + " TEXT,"
            + KEY_customer_to_phone + " TEXT,"
            + KEY_new_customer_type + " TEXT,"
            + KEY_IS_DISPATCH + " TEXT,"
            + KEY_READ_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_RETAILER_DISPATCH_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_DISPATCH_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_RETAILER_DISPATCH_ID + " INTEGER,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_IS_NEW_CUSTOMER + " TEXT,"
            + KEY_DISPATCH_DATE + " TEXT,"
            /*+ KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"*/
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_READ + " TEXT,"
            + KEY_customer_to_name + " TEXT,"
            + KEY_customer_to_phone + " TEXT,"
            + KEY_new_customer_type + " TEXT,"
            + KEY_IS_DISPATCH + " TEXT,"
            + KEY_READ_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_RETAILER_DISPATCH_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_DISPATCH_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_RETAILER_DISPATCH_PRODUCT_ID + " INTEGER,"
            + KEY_RETAILER_DISPATCH_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_ID + " INTEGER,"
            + KEY_STICKER_DETAILS_ID + " INTEGER,"
            + KEY_BTC_NO + " TEXT,"
            + KEY_qr_code + " TEXT,"
            + KEY_BTC_TYPE + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + DISPATCH_SCAN_TYPE + " TEXT)";

    /*public void insertBarcodeDetailsNoSticker(BarcodeModel barcodeModel,
                                              String isFrom, String cfa_dispatch_id, String brNo, int
                                                      isValid, String
                                                      validWhat, String userId, String syncCode) {
        SQLiteDatabase db = writeDB();
        ContentValues cv = new ContentValues();
        //Calendar c = Calendar.getInstance();
        //SimpleDateFormat df = new SimpleDateFormat("dd-MM-yyyy");
        String formattedDate = AppUtil.getCurrentDate(AppUtil.DATE_FORMAT);

        String btcNoOut = "";
        String qrNoOut = "";
        String barcodeNo = "";
        if (barcodeModel.getBarcodeNo().length() >= 12) {
            qrNoOut = barcodeModel.getBarcodeNo();
        } else {
            btcNoOut = barcodeModel.getBarcodeNo();
        }

        if (isFrom.equalsIgnoreCase("L3")) {
            // DIST Distributor
            cv.put(KEY_DISTRIBUTOR_DISPATCH_PRODUCT_ID, getProductId());
            cv.put(KEY_DISTRIBUTOR_DISPATCH_ID, cfa_dispatch_id);
            cv.put(KEY_PRODUCT_SKU_ID, 0);
            cv.put(KEY_STICKER_DETAILS_ID, 0);
            cv.put(KEY_BTC_NO_OUT, btcNoOut);
            cv.put(KEY_QR_CODE_OUT, qrNoOut);
            cv.put(KEY_QUANTITY, 1);
            cv.put(KEY_AMOUNT, 0);
            cv.put(KEY_UNIT, "box");
            cv.put(KEY_QTY_KGL, 0);
            cv.put(KEY_SYNC_CODE, syncCode);
            cv.put(KEY_SYNC_FLAG, "Y");
            cv.put(KEY_SYNC_DATE, formattedDate);
            cv.put(KEY_SYNC_USER, userId);
            cv.put(KEY_IS_VALID, isValid);
            db.insert(TABLE_DISTRIBUTOR_DISPATCH_PRODUCT, null, cv);
        } else if (isFrom.equalsIgnoreCase("L4")) {
            //CFA CFA
            cv.put(KEY_CFA_DISPATCH_PRODUCT_ID, getProductId());
            cv.put(KEY_CFA_DISPATCH_ID, cfa_dispatch_id);
            cv.put(KEY_PRODUCT_SKU_ID, 0);
            cv.put(KEY_BTC_NO_OUT, btcNoOut);
            cv.put(KEY_QR_CODE_OUT, qrNoOut);
            cv.put(KEY_IS_VALID, isValid);
            cv.put(KEY_STICKER_DETAILS_ID, 0);
            cv.put(KEY_QUANTITY, 1);
            cv.put(KEY_AMOUNT, 0);
            cv.put(KEY_UNIT, "box");
            cv.put(KEY_QTY_KGL, 0);
            cv.put(KEY_SYNC_CODE, syncCode);
            cv.put(KEY_SYNC_FLAG, "Y");
            cv.put(KEY_SYNC_DATE, formattedDate);
            cv.put(KEY_SYNC_USER, userId);
            db.insert(TABLE_CFA_DISPATCH_PRODUCT, null, cv);
        } else if (isFrom.equalsIgnoreCase("TOL")) {
            // TOL Toller
         *//*cv.put(KEY_TOLLER_DISPATCH_PRODUCT_ID, getProductId());
         cv.put(KEY_TOLLER_DISPATCH_ID, cfa_dispatch_id);
         cv.put(KEY_PRODUCT_SKU_ID, 0);
         cv.put(KEY_STICKER_ID, 0);
         cv.put(KEY_BATCH_NO, btcNoOut);
         cv.put(KEY_QR_CODE_OUT, qrNoOut);
         cv.put(KEY_QUANTITY, 1);
         cv.put(KEY_AMOUNT, 0);
         cv.put(KEY_UNIT, 1);
         cv.put(KEY_QTY_KGL, "box");
         cv.put(KEY_RECEIVED, "Y");
         cv.put(KEY_RECEIVED_DATE, formattedDate);
         cv.put(KEY_SYNC_CODE, syncCode);
         cv.put(KEY_SYNC_FLAG, "Y");
         cv.put(KEY_SYNC_DATE, formattedDate);
         cv.put(KEY_SYNC_USER, userId);
         db.insert(TABLE_TOLLER_DISPATCH_PRODUCT, null, cv);*//*
        } else if (isFrom.equalsIgnoreCase("L2")) {
            //RET Retailer
            cv.put(KEY_RETAILER_DISPATCH_PRODUCT_ID, getProductId());
            cv.put(KEY_RETAILER_DISPATCH_ID, cfa_dispatch_id);
            cv.put(KEY_PRODUCT_SKU_ID, 0);
            cv.put(KEY_STICKER_DETAILS_ID, 0);
            cv.put(KEY_BTC_NO, btcNoOut);
            cv.put(KEY_QR_CODE_OUT, qrNoOut);
            cv.put(KEY_BTC_TYPE, 0);
            cv.put(KEY_QUANTITY, 1);
            cv.put(KEY_AMOUNT, 0);
            cv.put(KEY_UNIT, "box");
            cv.put(KEY_QTY_KGL, 0);
            cv.put(KEY_IS_VALID, isValid);
            cv.put(KEY_SYNC_CODE, syncCode);
            cv.put(KEY_SYNC_FLAG, "Y");
            cv.put(KEY_SYNC_DATE, formattedDate);
            cv.put(KEY_SYNC_USER, userId);
            db.insert(TABLE_RETAILER_DISPATCH_PRODUCT, null, cv);
        } else {
            //FAR Farmer

        }
    }*/

    /*private int getProductId() {
        int pid = 0;
        SQLiteDatabase db = writeDB();
        Cursor cursor = db.rawQuery("Select cfa_dispatch_product_id from bf_ishop_cfa_dispatch_product",
        null);
        if (cursor != null && cursor.getCount() > 0) {
            while (cursor.moveToNext()) {
                pid = cursor.getInt(cursor.getColumnIndex("cfa_dispatch_product_id"));
            }
        }
        cursor.close();
        pid++;
        return pid;
    }*/
    private static final String CREATE_TABLE_RETAILER_RETURN = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_RETURN
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_RETAILER_RETURN_ID + " TEXT,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_IS_NEW_CUSTOMER + " TEXT,"
            + KEY_RETURN_DATE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String CREATE_TABLE_RETAILER_RETURN_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_RETURN_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_RETAILER_RETURN_ID + " TEXT,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_IS_NEW_CUSTOMER + " TEXT,"
            + KEY_RETURN_DATE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_RETAILER_RETURN_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_RETURN_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_RETAILER_RETURN_PRODUCT_ID + " TEXT,"
            + KEY_RETAILER_RETURN_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";
    private static final String CREATE_TABLE_DISTRIBUTOR_RETURN_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_RETURN_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_RETURN_ID + " TEXT,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_IS_NEW_CUSTOMER + " TEXT,"
            + KEY_RETURN_DATE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String CREATE_TABLE_DISTRIBUTOR_RETURN = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_RETURN
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_RETURN_ID + " TEXT,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_IS_NEW_CUSTOMER + " TEXT,"
            + KEY_RETURN_DATE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_DISTRIBUTOR_RETURN_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_RETURN_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_RETURN_PRODUCT_ID + " TEXT,"
            + KEY_DISTRIBUTOR_RETURN_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";
    private static final String CREATE_TABLE_DISTRIBUTOR_RETURN_REQUEST = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_RETURN_REQUEST
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_RETURN_REQUEST_ID + " TEXT,"
            + SRIP_ID + " TEXT,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_RETURN_REQUEST_DATE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_isDispatch + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_RETURN_REQUEST_ID + " TEXT,"
            + SRIP_ID + " TEXT,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_RETURN_REQUEST_DATE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_isDispatch + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_ID + " TEXT,"
            + KEY_DISTRIBUTOR_RETURN_REQUEST_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_REJECT + " TEXT,"
            + KEY_REJECT_DATE + " TEXT ,"
            + KEY_REJECT_REASON + " TEXT,"
            + KEY_REJECT_ID + " TEXT)";
    private static final String CREATE_TABLE_CFA_RETURN = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_RETURN
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CFA_RETURN_ID + " TEXT,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            /*+ KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_IS_NEW_CUSTOMER + " TEXT,"*/
            + KEY_RETURN_DATE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_IS_DISPATCH + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String CREATE_TABLE_CFA_RETURN_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_RETURN_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CFA_RETURN_ID + " TEXT,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_RETURN_DATE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_IS_DISPATCH + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_CFA_RETURN_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_RETURN_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CFA_RETURN_PRODUCT_ID + " TEXT,"
            + KEY_CFA_RETURN_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";
    private static final String CREATE_TABLE_CPM_STOCK = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CPM_STOCK
            + "("
            + KEY_CPM_STOCK_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_STOCK_DATE + " TEXT,"
            + KEY_CUSTOMER_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT)";
    private static final String CREATE_TABLE_CPM_STOCK_DETAILS = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CPM_STOCK_DETAILS
            + "("
            + KEY_CPM_STOCK_DETAILS_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CPM_STOCK_ID + " TEXT,"
            + KEY_CUSTOMER_ID + " TEXT,"
            + KEY_TRANSACTIONS_TYPE + " TEXT,"
            + KEY_TRANSACTIONS_DATE + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_ENTRY_FROM + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";
    private static final String CREATE_TABLE_CUSTOMER_DETAILS = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CUSTOMER_DETAILS
            + "("
            + KEY_ID + " TEXT ,"
            + KEY_EMAIL + " TEXT,"
            + KEY_USER_CODE + " TEXT,"
            + KEY_BUSSINESS_CODE + " TEXT,"
            + KEY_DISPLAY_NAME + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_CODE + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_NAME + " TEXT,"
            + KEY_CUSTOMER_TYPE_REGIONAL_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_REGIONAL_NAME + " TEXT,"
            + KEY_CUSTOMER_TYPE_REGIONAL_CODE + " TEXT,"
            + KEY_POLITICAL_GEO_ID + " TEXT,"
            + KEY_political_geography_countrylevel_id + " TEXT,"
            + KEY_political_regional_level + " TEXT,"
            + KEY_CUSTOMER_TYPE_REGIONAL_LEVEL + " TEXT,"
            + KEY_SAP_ID + " TEXT,"
            + KEY_PARENT_USER_ID + " TEXT,"
            + KEY_PRIMARY_MOBILE_NO + " TEXT)";


    private static final String CREATE_TABLE_PRODUCT_TYPE_NAME_COUNTRY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_PRODUCT_TYPE_NAME_COUNTRY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_PRODUCT_COUNTRY_ID + " TEXT ,"
            + KEY_PRODUCT_REGIONAL_ID + " TEXT,"
            + KEY_PRODUCT_COUNTRY_NAME + " TEXT,"
            + KEY_PRODUCT_REGIONAL_CODE + " TEXT,"
            + KEY_DESCRIPTION + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_DELETED + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT)";

    private static final String CREATE_TABLE_STICKER_DETAILS = "CREATE TABLE IF NOT EXISTS "
            + TABLE_STICKER_DETAILS
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_STICKER_ID + " TEXT,"
            + KEY_BTC_NO_IN + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_IN + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_STICKER_NO + " TEXT,"
            + KEY_IS_BUFFER + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_CUSTOMER_ID + " TEXT,"
            + KEY_DELETED + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_ANDROID_SYNC + " TEXT,"
            + KEY_PALLET_DETAIL_ID + " INTEGER DEFAULT 0)";


    private static final String CREATE_TABLE_STICKER_DETAILS_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_STICKER_DETAILS_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_STICKER_ID + " TEXT,"
            + KEY_BTC_NO_IN + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_IN + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_STICKER_NO + " TEXT,"
            + KEY_IS_BUFFER + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_CUSTOMER_ID + " TEXT,"
            + KEY_DELETED + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_ANDROID_SYNC + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_PALLET_DETAIL_ID + " INTEGER DEFAULT 0)";


    private static final String CREATE_TABLE_MASTER_PRODUCT_SKU_COUNTRY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_MASTER_PRODUCT_SKU_COUNTRY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_PRODUCT_SKU_COUNTRY_ID + " TEXT ,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_PRODUCT_SKU_NAME + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_DELETED + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_PBG_ID + " TEXT,"
            + KEY_PRODUCT_SKU_CODE + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT)";
    private static final String CREATE_TABLE_STICKER = "CREATE TABLE IF NOT EXISTS "
            + TABLE_STICKER
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_STICKER_ID + " TEXT,"
            + KEY_REF_ID + " TEXT,"
            + KEY_SYSTEM_CODE + " TEXT,"
            + KEY_TOLLER_CODE + " TEXT,"
            + KEY_CUSTOMER_ID + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_PRODUCTION_DATE + " TEXT,"
            + KEY_PBG_COUNTRY_ID + " TEXT,"
            + KEY_PRODUCT_SKU_COUNTRY_ID + " TEXT,"
            + KEY_BATCH_NO + " TEXT,"
            + KEY_BATCH_ID + " INTEGER,"
            + KEY_MFG_DATE + " TEXT,"
            + KEY_EXPIRE_DATE + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_BUFFER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_DRAFT + " TEXT,"
            + KEY_DRAFT_DATE + " TEXT,"
            + KEY_DRAFT_REASON + " TEXT,"
            + KEY_DELETED + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";
    private static final String CREATE_TABLE_MENU_ACCESS = "CREATE TABLE IF NOT EXISTS "
            + TABLE_MENU_ACCESS
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_ORDER + " TEXT ,"
            + KEY_ALIAS + " TEXT,"
            + KEY_MENU_ID + " TEXT,"
            + KEY_TITLE + " TEXT)";

    private static final String CREATE_TABLE_REJECTED_ORDER = "CREATE TABLE IF NOT EXISTS "
            + TABLE_REJECTED_ORDER
            + "(" +
            KEY_DISPLAY_NAME + " TEXT ," +
            KEY_CUSTOMER_FROM_ID + " TEXT ," +
            KEY_TOTAL_PRODUCT + " TEXT ," +
            KEY_QUANTITY + " TEXT ," +
            KEY_DISPATCH_DATE + " TEXT ," +
            KEY_DISPATCH_DATE_TIME + " TEXT ," +
            KEY_STDONO + " TEXT)";

    private static final String CREATE_TABLE_SCHEME_MASTER = "CREATE TABLE IF NOT EXISTS " +
            TABLE_SCHEME_MASTER + "(" + KEY_SCHEME_ID + " TEXT," +
            KEY_SCHEME_CODE + " TEXT," +
            KEY_SCHEME_NAME + " TEXT," +
            KEY_FROM_MONTH + " TEXT," +
            KEY_TO_MONTH + " TEXT," +
            KEY_PRODUCT_SKU_NAME + " TEXT," +
            KEY_PRODUCT_SKU_CODE + " TEXT," +
            KEY_VALUE_PER_POINT + " TEXT)";


    private static final String CREATE_TABLE_ISHOP_CFA_DAMAGE = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_DAMAGE
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + CFA_DAMAGE_ID + " TEXT,"
            + CUSTOMER_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + DAMAGE_DATE + " TEXT,"
            + ISDAMAGE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_ISHOP_CFA_DAMAGE_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_DAMAGE_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + CFA_DAMAGE_ID + " TEXT,"
            + CUSTOMER_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + DAMAGE_DATE + " TEXT,"
            + ISDAMAGE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_ISHOP_CFA_DAMAGE_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_DAMAGE_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + CFA_DAMAGE_PRODUCT_ID + " TEXT,"
            + CFA_DAMAGE_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String CREATE_TABLE_ISHOP_DISTRIBUTOR_DAMAGE = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_DAMAGE
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + DISTRIBUTOR_DAMAGE_ID + " TEXT,"
            + CUSTOMER_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + DAMAGE_DATE + " TEXT,"
            + ISDAMAGE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_ISHOP_DISTRIBUTOR_DAMAGE_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_DAMAGE_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + DISTRIBUTOR_DAMAGE_ID + " TEXT,"
            + CUSTOMER_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + DAMAGE_DATE + " TEXT,"
            + ISDAMAGE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String CREATE_TABLE_ISHOP_DISTRIBUTOR_DAMAGE_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_DAMAGE_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + DISTRIBUTOR_DAMAGE_PRODUCT_ID + " TEXT,"
            + DISTRIBUTOR_DAMAGE_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String CREATE_TABLE_ISHOP_RETAILER_DAMAGE = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_DAMAGE
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + RETAILER_DAMAGE_ID + " TEXT,"
            + CUSTOMER_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + DAMAGE_DATE + " TEXT,"
            + ISDAMAGE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_ISHOP_RETAILER_DAMAGE_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_DAMAGE_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + RETAILER_DAMAGE_ID + " TEXT,"
            + CUSTOMER_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + DAMAGE_DATE + " TEXT,"
            + ISDAMAGE + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String CREATE_TABLE_ISHOP_RETAILER_DAMAGE_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_DAMAGE_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + RETAILER_DAMAGE_PRODUCT_ID + " TEXT,"
            + RETAILER_DAMAGE_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO + " TEXT,"
            + KEY_qr_code + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String DATABASE_CREATE_TABLE_POLITICAL_LEVEL = "CREATE TABLE IF NOT EXISTS " +
            TABLE_POLITICAL_LEVEL + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_POLITICAL_GEOGRAPHY_COUNTRY_LEVEL_ID + " INTEGER,"
            + KEY_LEVEL_NAME + " TEXT,"
            + KEY_LEVEL + " TEXT"
            + ")";
    private static final String DATABASE_CREATE_TABLE_POLITICAL_DETAILS = "CREATE TABLE IF NOT EXISTS " +
            TABLE_POLITICAL_DETAILS + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_POLITICAL_GEO_ID + " TEXT,"
            + KEY_GEO_LEVEL_ID + " TEXT,"
            + KEY_PARENT_GEO_ID + " TEXT,"
            + KEY_POLITICAL_GEOGRAPHY_CODE + " TEXT,"
            + KEY_POLITICAL_GEOGRAPHY_NAME + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFICATION_BY_USER + " TEXT,"
            + KEY_DELETED + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT"
            + ")";
    private static final String DATABASE_CREATE_TABLE_CUSTOMER_PRODUCT_STOCK = "CREATE TABLE IF NOT EXISTS " +
            TABLE_CUSTOMER_PRODUCT_STOCK + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CUSTOMER_PRODUCT_STOCK_ID + " TEXT,"
            + KEY_CUSTOMER_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_PRODUCT_STOCK_BOX + " TEXT,"
            + KEY_BATCH_NO + " TEXT,"
            + KEY_PRODUCT_STOCK_KGL + " TEXT,"
            + KEY_EXPIRE_DATE + " TEXT)";


    private static final String CREATE_TABLE_CUSTOMER_PRODUCT_DAMAGE_STOCK = "CREATE TABLE IF NOT EXISTS " +
            TABLE_CUSTOMER_PRODUCT_DAMAGE_STOCK + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CUSTOMER_PRODUCT_DAMAGE_STOCK_ID + " TEXT,"
            + KEY_CUSTOMER_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_PRODUCT_STOCK_BOX + " TEXT,"
            + KEY_BATCH_NO + " TEXT,"
            + KEY_PRODUCT_STOCK_KGL + " TEXT,"
            + KEY_EXPIRE_DATE + " TEXT)";
    //Login Table::
    private static final String CREATE_TABLE_LOGIN = "CREATE TABLE  " + LOGIN_MASTER + "(" + INTGLCODE + " " +
            "INTEGER PRIMARY KEY AUTOINCREMENT," +
            VAR_USERNAME + " TEXT," +
            VAR_PASSWORD + " TEXT," +
            VAR_PERSONNAME + " TEXT," +
            KEY_COUNTRY_ID + " TEXT," +
            KEY_COUNTRY_CODE + " TEXT," +
            FK_PERSONGICODE + " INTEGER," +
            FK_EMPGLCODE + " INTEGER," +
            VAR_MOBILENUMBER + " TEXT," +
            VAR_LASTSYNCTIME + " TEXT," +
            VAR_ClIENTNAME + " TEXT," +
            IS_AUTHORISED + " TEXT," +
            IS_SMSON + " TEXT," +
            IMEI + " TEXT," +
            KEY_PARENT_ID + " TEXT)";
    //retailer_received_id
    private static final String CREATE_TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED = "CREATE TABLE IF NOT EXISTS " +
            TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            DISTRIBUTOR_RECEIVED_ID + " TEXT," +
            KEY_CUSTOMER_FROM_ID + " TEXT," +
            KEY_CUSTOMER_TO_ID + " TEXT," +
            KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT," +
            // IS_NEW_CUSTOMER + " TEXT," +
            KEY_RECEIVED_DATE + " TEXT," +
            KEY_COUNTRY_ID + " TEXT," +
            KEY_CREATED_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT," +
            KEY_STATUS + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            KEY_isDispatch + " TEXT," +
            SYNC_BY_USER + " TEXT)";


    private static final String CREATE_TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_COPY = "CREATE TABLE IF NOT EXISTS " +
            TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_COPY +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            DISTRIBUTOR_RECEIVED_ID + " TEXT," +
            KEY_CUSTOMER_FROM_ID + " TEXT," +
            KEY_CUSTOMER_TO_ID + " TEXT," +
            KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT," +
            // IS_NEW_CUSTOMER + " TEXT," +
            KEY_RECEIVED_DATE + " TEXT," +
            KEY_COUNTRY_ID + " TEXT," +
            KEY_CREATED_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT," +
            KEY_STATUS + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            KEY_isDispatch + " TEXT," +
            SYNC_BY_USER + " TEXT)";

    private static final String CREATE_TABLE_BF_ISHOP_RETAILER_RECEIVED = "CREATE TABLE IF NOT EXISTS " +
            TABLE_BF_ISHOP_RETAILER_RECEIVED +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            RETAILER_RECEIVED_ID + " TEXT," +
            KEY_CUSTOMER_FROM_ID + " TEXT," +
            KEY_CUSTOMER_TO_ID + " TEXT," +
            KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT," +
            // IS_NEW_CUSTOMER + " TEXT," +
            KEY_RECEIVED_DATE + " TEXT," +
            KEY_COUNTRY_ID + " TEXT," +
            KEY_CREATED_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT," +
            KEY_STATUS + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            KEY_isDispatch + " TEXT," +
            SYNC_BY_USER + " TEXT)";

    private static final String CREATE_TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY = "CREATE TABLE IF NOT EXISTS " +
            TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            RETAILER_RECEIVED_ID + " TEXT," +
            KEY_CUSTOMER_FROM_ID + " TEXT," +
            KEY_CUSTOMER_TO_ID + " TEXT," +
            KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT," +
            // IS_NEW_CUSTOMER + " TEXT," +
            KEY_RECEIVED_DATE + " TEXT," +
            KEY_COUNTRY_ID + " TEXT," +
            KEY_CREATED_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT," +
            KEY_STATUS + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            KEY_isDispatch + " TEXT," +
            SYNC_BY_USER + " TEXT)";

    private static final String CREATE_TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT = "CREATE TABLE IF NOT " +
            "EXISTS " +
            TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            DISTRIBUTOR_RECEIVED_PRODUCT_ID + " TEXT," +
            DISTRIBUTOR_RECEIVED_ID + " TEXT," +
            KEY_PRODUCT_SKU_ID + " TEXT," +
            KEY_STICKER_DETAILS_ID + " TEXT," +
            BTC_NO_OUT + " TEXT," +
            KEY_QR_CODE_OUT + " TEXT," +
            KEY_QUANTITY + " TEXT," +
            KEY_AMOUNT + " TEXT," +
            KEY_UNIT + " TEXT," +
            KEY_QTY_KGL + " TEXT," +
            KEY_IS_VALID + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            SYNC_BY_USER + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_CREATE_BY + " TEXT)";
//    /*RETAILER QUERIES PENDING*/
//    private static final String CREATE_TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT = "CREATE TABLE IF NOT " +
//            "EXISTS " +
//            TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT +
//            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
//            RETAILER_RECEIVED_PRODUCT_ID + " TEXT," +
//            RETAILER_RECEIVED_ID + " TEXT," +
//            KEY_PRODUCT_SKU_ID + " TEXT," +
//            KEY_STICKER_DETAILS_ID + " TEXT," +
//            BTC_NO_OUT + " TEXT," +
//            KEY_QR_CODE_OUT + " TEXT," +
//            KEY_QUANTITY + " TEXT," +
//            KEY_AMOUNT + " TEXT," +
//            KEY_UNIT + " TEXT," +
//            KEY_QTY_KGL + " TEXT," +
//            KEY_IS_VALID + " TEXT," +
//            KEY_SYNC_CODE + " TEXT," +
//            KEY_SYNC_FLAG + " TEXT," +
//            KEY_SYNC_DATE + " TEXT," +
//            SYNC_BY_USER + " TEXT," +
//            KEY_CREATE_BY + " TEXT," +
//            KEY_CREATE_ON + " TEXT)";

    /*RETAILER QUERIES PENDING*/
    private static final String CREATE_TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT = "CREATE TABLE IF NOT " +
            "EXISTS " +
            TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            RETAILER_RECEIVED_PRODUCT_ID + " TEXT," +
            RETAILER_RECEIVED_ID + " TEXT," +
            KEY_PRODUCT_SKU_ID + " TEXT," +
            KEY_STICKER_DETAILS_ID + " TEXT," +
            BTC_NO_OUT + " TEXT," +
            KEY_QR_CODE_OUT + " TEXT," +
            KEY_QUANTITY + " TEXT," +
            KEY_AMOUNT + " TEXT," +
            KEY_UNIT + " TEXT," +
            KEY_QTY_KGL + " TEXT," +
            KEY_IS_VALID + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            SYNC_BY_USER + " TEXT," +
            KEY_CREATE_BY + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_OUT_POINT_CALCULATE + " TEXT," +
            KEY_RECEIVE_SCAN_TYPE + " TEXT)";

    private static final String CREATE_TABLE_SALES_REP_INITIATED_PRODUCT = "CREATE TABLE IF NOT EXISTS " +
            TABLE_SALES_REP_INITIATED_PRODUCT +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            SRIP_ID + " TEXT," +
            KEY_CUSTOMER_FROM_ID + " TEXT," +
            KEY_CUSTOMER_TO_ID + " TEXT," +
            FK_PBG_COUNTRY_ID + " TEXT," +
            FK_SKU_COUNTRY_ID + " TEXT," +
            DECQTY + " TEXT," +
            VARREMARKS + " TEXT," +
            KEY_DELETED + " TEXT," +
            KEY_STATUS + " TEXT," +
            KEY_CREATED_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            CREATED_BY_NAME + " TEXT," +
            MODIFIED_BY_NAME + " TEXT," +
            SYNC_BY_USER + " TEXT," +
            SCAN_COUNT + " TEXT)";
    private static final String CREATE_TABLE_CTOCMAPPING = "CREATE TABLE IF NOT EXISTS " +
            TABLE_CTOCMAPPING +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            FROM_CUSTOMER_ID + " TEXT," +
            TO_CUSTOMER_ID + " TEXT)";


    private static final String CREATE_TABLE_CTOEMAPPING = "CREATE TABLE IF NOT EXISTS " +
            TABLE_CTOEMAPPING +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            EMPLOYEE_ID + " TEXT," +
            CUSTOMER_ID + " TEXT," +
            USER_CODE + " TEXT," +
            DISPLAY_NAME + " TEXT," +
            EMAIL + " TEXT," +
            PRIMARY_MOBILE_NO + " TEXT)";

    private static final String CREATE_TABLE_CustomerType_Details = "CREATE TABLE IF NOT EXISTS " +
            TABLE_CustomerType_Details +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT," +
            KEY_Customer_type_name_country + " TEXT," +
            KEY_customer_level + " TEXT," +
            KEY_customer_type_name + " TEXT," +
            AUTO_SYNC + " TEXT," +
            AUTO_SYNC_DAY + " TEXT)";

    private static final String CREATE_TABLE_RTORMAPPING = "CREATE TABLE IF NOT EXISTS " +
            TABLE_RTORMAPPING +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            FROM_CUSTOMER_LEVEL + " TEXT," +
            FROM_CUSTOMER_ID + " TEXT," +
            TO_CUSTOMER_LEVEL + " TEXT," +
            TO_CUSTOMER_ID + " TEXT)";


    private static final String CREATE_TABLE_RTODMAPPING = "CREATE TABLE IF NOT EXISTS " +
            TABLE_DTORMAPPING +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            FROM_CUSTOMER_LEVEL + " TEXT," +
            FROM_CUSTOMER_ID + " TEXT," +
            TO_CUSTOMER_LEVEL + " TEXT," +
            TO_CUSTOMER_ID + " TEXT)";
    private final Context context;


    private final String TAG = "DataBaseHelper";
    public static String DB_Path = "";
    public static final String DBPs = "Vcs@1234";
    private static DataBaseHelper sInstance;

    public DataBaseHelper(Context context) {
        super(context, DATABASE_NAME, null, DATABASE_VERSION);
        this.context = context;
        DB_Path = context.getDatabasePath(DATABASE_NAME).getPath();

//        databaseFile = context.getDatabasePath(DATABASE_NAME);
//        database = SQLiteDatabase.openOrCreateDatabase(databaseFile, DBPs, null);
    }

    public static synchronized DataBaseHelper getInstance(Context context) {

        // Use the application context, which will ensure that you
        // don't accidentally leak an Activity's context.
        // See this article for more information: http://bit.ly/6LRzfx
        if (sInstance == null) {
            sInstance = new DataBaseHelper(context.getApplicationContext());
        }
        return sInstance;
    }

    public SQLiteDatabase writeDB() {
        SQLiteDatabase db = getWritableDatabase();
        if (db.isOpen() && db.isReadOnly()) {
            db = getWritableDatabase();
        }
        return db;
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        /*if (oldVersion < newVersion) {
            if (oldVersion == 38) {
                db.beginTransaction();
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            }else if (oldVersion == 37) {
                db.beginTransaction();
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            }else if (oldVersion == 36) {
                db.beginTransaction();
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 35) {
                db.beginTransaction();
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 34) {
                db.beginTransaction();
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 33) {
                db.beginTransaction();
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 32) {
                db.beginTransaction();
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 31) {
                db.beginTransaction();
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 30) {
                db.beginTransaction();
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 29) {
                db.beginTransaction();
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 28) {
                db.beginTransaction();
//                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 27) {
                db.beginTransaction();
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 26) {
                db.beginTransaction();
                onUpgrade26India(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 25) {
                db.beginTransaction();
//                onUpgrade26(db);
                onUpgrade26India(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 24) {
                db.beginTransaction();
                onUpgrade26India(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 23) {
                db.beginTransaction();
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 22) {
                db.beginTransaction();
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 21) {
                db.beginTransaction();
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 20) {
                db.beginTransaction();
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 19) {
                db.beginTransaction();
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 18) {
                db.beginTransaction();
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 17) {
                db.beginTransaction();
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 16) {
                db.beginTransaction();
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 15) {
                db.beginTransaction();
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 14) {
                db.beginTransaction();
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 13) {
                db.beginTransaction();
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 12) {
                db.beginTransaction();
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 11) {
                db.beginTransaction();
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 10) {
                db.beginTransaction();
                onUpgrade11(db);
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 9) {
                db.beginTransaction();
                onUpgrade10(db);
                onUpgrade11(db);
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 8) {
                db.beginTransaction();
                onUpgrade9(db);
                onUpgrade10(db);
                onUpgrade11(db);
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 7) {
                db.beginTransaction();
                onUpgrade8(db);
                onUpgrade9(db);
                onUpgrade10(db);
                onUpgrade11(db);
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 6) {
                db.beginTransaction();
                onUpgrade7(db);
                onUpgrade8(db);
                onUpgrade9(db);
                onUpgrade10(db);
                onUpgrade11(db);
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 5) {
                db.beginTransaction();
                onUpgrade6(db);
                onUpgrade7(db);
                onUpgrade8(db);
                onUpgrade9(db);
                onUpgrade10(db);
                onUpgrade11(db);
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 4) {
                db.beginTransaction();
                onUpgrade5(db);
                onUpgrade6(db);
                onUpgrade7(db);
                onUpgrade8(db);
                onUpgrade9(db);
                onUpgrade10(db);
                onUpgrade11(db);
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 3) {
                db.beginTransaction();
                onUpgrade4(db);
                onUpgrade5(db);
                onUpgrade6(db);
                onUpgrade7(db);
                onUpgrade8(db);
                onUpgrade9(db);
                onUpgrade10(db);
                onUpgrade11(db);
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 2) {
                db.beginTransaction();
                onUpgrade3(db);
                onUpgrade4(db);
                onUpgrade5(db);
                onUpgrade6(db);
                onUpgrade7(db);
                onUpgrade8(db);
                onUpgrade9(db);
                onUpgrade10(db);
                onUpgrade11(db);
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            } else if (oldVersion == 1) {
                db.beginTransaction();
                onUpgrade2(db);
                onUpgrade3(db);
                onUpgrade4(db);
                onUpgrade5(db);
                onUpgrade6(db);
                onUpgrade7(db);
                onUpgrade8(db);
                onUpgrade9(db);
                onUpgrade10(db);
                onUpgrade11(db);
                onUpgrade12(db);
                onUpgrade13(db);
                onUpgrade14(db);
                onUpgrade15(db);
                onUpgrade16(db);
                onUpgrade17(db);
                onUpgrade18(db);
                onUpgrade19(db);
                onUpgrade20(db);
                onUpgrade21(db);
                onUpgrade22(db);
                onUpgrade23(db);
                onUpgrade24(db);
                onUpgrade25(db);
                onUpgrade26(db);
                onUpgrade27(db);
                onUpgrade28(db);
                onUpgrade29(db);
                onUpgrade30(db);
                onUpgrade31(db);
                onUpgrade32(db);
                onUpgrade33(db);
                onUpgrade34(db);
                onUpgrade35(db);
                onUpgrade36(db);
                onUpgrade37(db);
                onUpgrade38(db);
                onUpgrade39(db);
                db.setTransactionSuccessful();
                db.endTransaction();
                db.setVersion(newVersion);
            }
        }*/
    }

    @Override
    public void onCreate(SQLiteDatabase database) {

        database.execSQL(CREATE_TABLE_TOLLER_DISPATCH);
        database.execSQL(CREATE_TABLE_TOLLER_DISPATCH_COPY);
        database.execSQL(CREATE_TABLE_TOLLER_DISPATCH_PRODUCT);
        database.execSQL(CREATE_TABLE_CFA_DISPATCH);
        database.execSQL(CREATE_TABLE_CFA_DISPATCH_COPY);
        database.execSQL(CREATE_TABLE_CFA_DISPATCH_PRODUCT);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_DISPATCH);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_DISPATCH_COPY);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_DISPATCH_PRODUCT);
        database.execSQL(CREATE_TABLE_NEW_CUSTOMER);
        database.execSQL(CREATE_TABLE_RETAILER_DISPATCH);
        database.execSQL(CREATE_TABLE_RETAILER_DISPATCH_COPY);
        database.execSQL(CREATE_TABLE_RETAILER_DISPATCH_PRODUCT);
        database.execSQL(CREATE_TABLE_RETAILER_RETURN);
        database.execSQL(CREATE_TABLE_RETAILER_RETURN_COPY);
        database.execSQL(CREATE_TABLE_RETAILER_RETURN_PRODUCT);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_RETURN);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_RETURN_COPY);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_RETURN_PRODUCT);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_RETURN_REQUEST);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT);
        database.execSQL(CREATE_TABLE_CFA_RETURN);
        database.execSQL(CREATE_TABLE_CFA_RETURN_COPY);
        database.execSQL(CREATE_TABLE_CFA_RETURN_PRODUCT);
        // database.execSQL(CREATE_TABLE_CPM_STOCK);
        //database.execSQL(CREATE_TABLE_CPM_STOCK_DETAILS);
        database.execSQL(CREATE_TABLE_CUSTOMER_DETAILS);
        database.execSQL(CREATE_TABLE_ETORMAPPING);
        database.execSQL(CREATE_TABLE_PRODUCT_TYPE_NAME_COUNTRY);
        database.execSQL(CREATE_TABLE_STICKER_DETAILS);
        database.execSQL(CREATE_TABLE_MASTER_PRODUCT_SKU_COUNTRY);
        database.execSQL(CREATE_TABLE_STICKER);
        database.execSQL(CREATE_TABLE_MENU_ACCESS);
        database.execSQL(DATABASE_CREATE_TABLE_POLITICAL_LEVEL);
        database.execSQL(DATABASE_CREATE_TABLE_POLITICAL_DETAILS);
        database.execSQL(CREATE_TABLE_LOGIN);
        database.execSQL(DATABASE_CREATE_TABLE_CUSTOMER_PRODUCT_STOCK);
        database.execSQL(CREATE_TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED);
        database.execSQL(CREATE_TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_COPY);
        database.execSQL(CREATE_TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT);
        database.execSQL(CREATE_TABLE_BF_ISHOP_RETAILER_RECEIVED);
        database.execSQL(CREATE_TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY);
        database.execSQL(CREATE_TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT);
        database.execSQL(CREATE_TABLE_USER_CONFIGURATION_MST);
        database.execSQL(CREATE_TABLE_SALES_REP_INITIATED_PRODUCT);
        database.execSQL(CREATE_TABLE_CTOCMAPPING);
        database.execSQL(CREATE_TABLE_CTOEMAPPING);
        database.execSQL(CREATE_TABLE_Last_Sync_Date_Time);
        database.execSQL(CREATE_TABLE_CustomerType_Details);
        database.execSQL(CREATE_TABLE_RTORMAPPING);
        database.execSQL(CREATE_TABLE_RTODMAPPING);
        database.execSQL(CREATE_TABLE_RETAILER_SCANNED_IN_STICKER);
        database.execSQL(CREATE_TABLE_RETAILER_SCANNED_OUT_STICKER);
        database.execSQL(CREATE_TABLE_SCANNEDSTICKERS);
        database.execSQL(CREATE_TABLE_DISPATCH_BATCHWISE_STOCK_CALCULATE);
        database.execSQL(CREATE_TABLE_STICKER_DETAILS_COPY);
        database.execSQL(CREATE_TABLE_CFA_DISPATCH_PRODUCT_COPY);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY);
        database.execSQL(CREATE_TABLE_RETAILER_DISPATCH_PRODUCT_COPY);
        database.execSQL(CREATE_TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT_COPY);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_RETURN_PRODUCT_COPY);
        database.execSQL(CREATE_TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY);
        database.execSQL(CREATE_TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT_COPY);
        database.execSQL(CREATE_TABLE_RETAILER_RETURN_PRODUCT_COPY);
        database.execSQL(CREATE_TABLE_TOLLER_DISPATCH_PRODUCT_COPY);
        database.execSQL(CREATE_TABLE_CFA_RETURN_PRODUCT_COPY);
        database.execSQL(CREATE_TABLE_REJECTED_ORDER);
        database.execSQL(CREATE_TABLE_SCHEME_MASTER);


        database.execSQL(CREATE_TABLE_ISHOP_CFA_DAMAGE);
        database.execSQL(CREATE_TABLE_ISHOP_CFA_DAMAGE_COPY);
        database.execSQL(CREATE_TABLE_ISHOP_CFA_DAMAGE_PRODUCT);
        database.execSQL(CREATE_TABLE_ISHOP_DISTRIBUTOR_DAMAGE);
        database.execSQL(CREATE_TABLE_ISHOP_DISTRIBUTOR_DAMAGE_COPY);
        database.execSQL(CREATE_TABLE_ISHOP_DISTRIBUTOR_DAMAGE_PRODUCT);
        database.execSQL(CREATE_TABLE_ISHOP_RETAILER_DAMAGE);
        database.execSQL(CREATE_TABLE_ISHOP_RETAILER_DAMAGE_COPY);
        database.execSQL(CREATE_TABLE_ISHOP_RETAILER_DAMAGE_PRODUCT);
        database.execSQL(CREATE_TABLE_CUSTOMER_PRODUCT_DAMAGE_STOCK);

        database.execSQL(CREATE_TABLE_VIDEO_HELP);
        database.execSQL(CREATE_TABLE_MASTER_REASON);
        database.execSQL(CREATE_TABLE_SAVE_OFFLINE_LOG);
        database.execSQL(CREATE_TABLE_EXTRA_STICKER);
        database.execSQL(CREATE_TABLE_EXTRA_STICKER_COPY);
        database.execSQL(CREATE_TABLE_DEVICE_TOKEN);
        database.execSQL(CREATE_TABLE_YELLOW_LABEL_DISCARD);
        database.execSQL(CREATE_TABLE_YELLOW_LABEL_DISCARD_DETAILS);
        database.execSQL(CREATE_TABLE_CHECK_MAX_DATE);
        database.execSQL(CREATE_TABLE_SALES_REP_INITIATED_PRODUCT_CURRENT_LIMIT);
        database.execSQL(CREATE_TABLE_TRANSACTION_ERROR_LOG);
        database.execSQL(CREATE_TABLE_ISHOP_PALLET_DETAIL);
        database.execSQL(CREATE_TABLE_ISHOP_PALLET_DETAIL_COPY);
        database.execSQL(CREATE_TABLE_EXTRA_PALLET_STICKER_DETAIL);
        database.execSQL(CREATE_TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY);

        database.execSQL(CREATE_TABLE_WARE_HOUSE_DISPATCH_SCM);
        database.execSQL(CREATE_TABLE_WARE_HOUSE_DISPATCH_SCM_COPY);
        database.execSQL(CREATE_TABLE_STICKER_COPY);

        database.execSQL(CREATE_TABLE_EMPLOYEE_DETAILS);
        database.execSQL(DATABASE_CREATE_TABLE_POLITICAL_DETAILS_EMP);
        database.execSQL(CREATE_TABLE_SAMPLE_DISPATCH);
        database.execSQL(CREATE_TABLE_SAMPLE_DISPATCH_COPY);
        database.execSQL(CREATE_TABLE_SAMPLE_DISPATCH_PRODUCT);
        database.execSQL(CREATE_TABLE_SAMPLE_DISPATCH_PRODUCT_COPY);


        database.execSQL(CREATE_TABLE_EVOUCHER_SCAN);
        database.execSQL(CREATE_TABLE_MASTER_CONVERSION);
        database.execSQL(CREATE_TABLE_SKU_WISE_BLOCKING_DETAILS);
        database.execSQL(CREATE_TABLE_LOOKUP_VALUES_CONFIG);

        //b2c
        database.execSQL(CREATE_TABLE_B2C_CONFIG);
        database.execSQL(CREATE_TABLE_B2C_LOGIN_LOG);
        database.execSQL(CREATE_TABLE_B2C_LOGIN);


//        database.execSQL(CREATE_TABLE_LAST_SYNC_SCAN_DATE);


//        database.execSQL("CREATE INDEX ndx_barcodeNo ON table_scannedsticker (barcodeNo);");
//        database.execSQL("CREATE INDEX ndx_bf_ishop_sticker_details_bno ON ishop_sticker_details (btc_no_out)");
//        database.execSQL("CREATE INDEX ndx_bf_ishop_sticker_details_bni ON ishop_sticker_details (btc_no_in)");
//
//
//        database.execSQL("CREATE INDEX bf_ishop_cfa_return_product_cri ON bf_ishop_cfa_return_product (cfa_return_id)");
//        database.execSQL("CREATE INDEX bf_ishop_cfa_return_product_psi ON bf_ishop_cfa_return_product (product_sku_id)");
//        database.execSQL("CREATE INDEX bf_ishop_distributor_return_request_product_psi ON bf_ishop_distributor_return_request_product (distributor_return_request_id)");


        try {
            if (Build.VERSION.SDK_INT <= Build.VERSION_CODES.N) {
                database.execSQL("CREATE INDEX ndx_bf_ishop_cfa_dispatch_product_bni ON bf_ishop_cfa_dispatch_product (sticker_details_id)");
                database.execSQL("CREATE INDEX ndx_bf_ishop_sticker_details_bni_2 ON ishop_sticker_details (sticker_details_id)");
            }

//            String customer_level = Content.getPreferenceValue(context, Const.CUSTOMER_LEVEL);
//            if (customer_level.equalsIgnoreCase("L4")){
//                database.execSQL("CREATE INDEX ndx_barcodeNo ON table_scannedsticker (barcodeNo);");
//                database.execSQL("CREATE INDEX ndx_bf_ishop_sticker_details_bno ON ishop_sticker_details (btc_no_out)");
//                database.execSQL("CREATE INDEX ndx_bf_ishop_sticker_details_bni ON ishop_sticker_details (btc_no_in)");
//            }

            database.execSQL("CREATE INDEX bf_ishop_cfa_return_product_cri ON bf_ishop_cfa_return_product (cfa_return_id)");
            database.execSQL("CREATE INDEX bf_ishop_cfa_return_product_psi ON bf_ishop_cfa_return_product (product_sku_id)");
            database.execSQL("CREATE INDEX bf_ishop_distributor_return_request_product_psi ON bf_ishop_distributor_return_request_product (distributor_return_request_id)");
        } catch (SQLException e) {
            e.printStackTrace();
        }


        Log.e(TAG, "*****************************************************************");
        Log.e(TAG, "****************TABLE CREATE SUCCESSFULLY************************");
        Log.e(TAG, "*****************************************************************");
    }

    public int getCountryId(String keyUserId) {
        int country_id = 0;
        SQLiteDatabase db = writeDB();
        String qry = "SELECT country_id FROM login WHERE fk_empGlcode = " + keyUserId + ";";
        Cursor cursor = db.rawQuery(qry, null);
        if (cursor != null && cursor.getCount() > 0) {
            while (cursor.moveToNext()) {
                country_id = cursor.getInt(cursor.getColumnIndex("country_id"));
            }
        }
        assert cursor != null;
        cursor.close();
        return country_id;
    }

    public synchronized String getSyncDateAndTime() {
        String syncTime = "";
        try {
            SQLiteDatabase db = writeDB();
            String sql = "Select * from " + TABLE_Last_Sync_Date_Time;
            Cursor cursor = db.rawQuery(sql, null);
            if (cursor != null && cursor.getCount() > 0) {
                while (cursor.moveToNext()) {
                    syncTime = cursor.getString(cursor.getColumnIndex("Last_Sync_Date_Time"));
                }
            }
            if (cursor != null) cursor.close();
            return syncTime;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return syncTime;
    }

    private static final String CREATE_TABLE_ETORMAPPING = "CREATE TABLE IF NOT EXISTS "
            + TABLE_ETORMAPPING
            + "("
            + KEY_ID + " TEXT ,"
            + KEY_EMAIL + " TEXT,"
            + KEY_USER_CODE + " TEXT,"
            + KEY_BUSSINESS_CODE + " TEXT,"
            + KEY_DISPLAY_NAME + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_CODE + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_NAME + " TEXT,"
            + KEY_CUSTOMER_TYPE_REGIONAL_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_REGIONAL_NAME + " TEXT,"
            + KEY_CUSTOMER_TYPE_REGIONAL_CODE + " TEXT,"
            + KEY_POLITICAL_GEO_ID + " TEXT,"
            + KEY_political_geography_countrylevel_id + " TEXT,"
            + KEY_political_regional_level + " TEXT,"
            + KEY_CUSTOMER_TYPE_REGIONAL_LEVEL + " TEXT,"
            + KEY_SAP_ID + " TEXT,"
            + DISPATCH_SCAN_TYPE + " TEXT,"
            + PRIMARY_MOBILE_NO + " TEXT)";
    //
    private static final String CREATE_TABLE_RETAILER_SCANNED_IN_STICKER = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_SCANNED_IN_STICKER
            + "("
            + KEY_ID + " TEXT ,"
            + TOTALINSCANNED + " TEXT,"
            + DTMONTH + " TEXT)";

    public String getLoginId() {
        String loginId = "";
        try {
            SQLiteDatabase db = writeDB();
            String sql = "Select fk_personGlcode from login";
            Log.e("getLoginId", "" + sql);
            Cursor cursor = db.rawQuery(sql, null);
            if (cursor != null && cursor.getCount() > 0) {
                while (cursor.moveToNext()) {
                    loginId = cursor.getString(cursor.getColumnIndex("fk_personGlcode"));
                }
            }
            assert cursor != null;
            cursor.close();

        } catch (Exception e) {
            e.printStackTrace();
        }
        return loginId;
    }

    private static final String CREATE_TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_DISPATCH_PRODUCT_ID + " INTEGER,"
            + KEY_DISTRIBUTOR_DISPATCH_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_ID + " INTEGER,"
            + KEY_STICKER_DETAILS_ID + " INTEGER,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + DISPATCH_SCAN_TYPE + " TEXT,"
            + KEY_BTC_TYPE + " TEXT)";

    private static final String CREATE_TABLE_RETAILER_DISPATCH_PRODUCT_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_DISPATCH_PRODUCT_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_RETAILER_DISPATCH_PRODUCT_ID + " INTEGER,"
            + KEY_RETAILER_DISPATCH_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_ID + " INTEGER,"
            + KEY_STICKER_DETAILS_ID + " INTEGER,"
            + KEY_BTC_NO + " TEXT,"
            + KEY_qr_code + " TEXT,"
            + KEY_BTC_TYPE + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + DISPATCH_SCAN_TYPE + " TEXT)";

    private static final String CREATE_TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT_COPY = "CREATE TABLE IF NOT " +
            "EXISTS " +
            TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT_COPY +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            DISTRIBUTOR_RECEIVED_PRODUCT_ID + " TEXT," +
            DISTRIBUTOR_RECEIVED_ID + " TEXT," +
            KEY_PRODUCT_SKU_ID + " TEXT," +
            KEY_STICKER_DETAILS_ID + " TEXT," +
            BTC_NO_OUT + " TEXT," +
            KEY_QR_CODE_OUT + " TEXT," +
            KEY_QUANTITY + " TEXT," +
            KEY_AMOUNT + " TEXT," +
            KEY_UNIT + " TEXT," +
            KEY_QTY_KGL + " TEXT," +
            KEY_IS_VALID + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            SYNC_BY_USER + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_CREATE_BY + " TEXT)";

    private static final String CREATE_TABLE_DISTRIBUTOR_RETURN_PRODUCT_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_RETURN_PRODUCT_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_RETURN_PRODUCT_ID + " TEXT,"
            + KEY_DISTRIBUTOR_RETURN_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_ID + " TEXT,"
            + KEY_DISTRIBUTOR_RETURN_REQUEST_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_REJECT + " TEXT,"
            + KEY_REJECT_DATE + " TEXT ,"
            + KEY_REJECT_REASON + " TEXT,"
            + KEY_REJECT_ID + " TEXT)";

    /*RETAILER QUERIES PENDING*/
    private static final String CREATE_TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT_COPY = "CREATE TABLE IF NOT " +
            "EXISTS " +
            TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT_COPY +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            RETAILER_RECEIVED_PRODUCT_ID + " TEXT," +
            RETAILER_RECEIVED_ID + " TEXT," +
            KEY_PRODUCT_SKU_ID + " TEXT," +
            KEY_STICKER_DETAILS_ID + " TEXT," +
            BTC_NO_OUT + " TEXT," +
            KEY_QR_CODE_OUT + " TEXT," +
            KEY_QUANTITY + " TEXT," +
            KEY_AMOUNT + " TEXT," +
            KEY_UNIT + " TEXT," +
            KEY_QTY_KGL + " TEXT," +
            KEY_IS_VALID + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            SYNC_BY_USER + " TEXT," +
            KEY_CREATE_BY + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_OUT_POINT_CALCULATE + " TEXT," +
            KEY_RECEIVE_SCAN_TYPE + " TEXT)";

    private static final String CREATE_TABLE_RETAILER_RETURN_PRODUCT_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_RETURN_PRODUCT_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_RETAILER_RETURN_PRODUCT_ID + " TEXT,"
            + KEY_RETAILER_RETURN_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_TOLLER_DISPATCH_PRODUCT_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_TOLLER_DISPATCH_PRODUCT_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_TOLLER_DISPATCH_PRODUCT_ID + " INTEGER,"
            + KEY_TOLLER_DISPATCH_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_COUNTRY_ID + " INTEGER,"
            + KEY_STICKER_ID + " INTEGER,"
            + KEY_BATCH_NO + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT," +
            KEY_READ + " TEXT," +
            KEY_READ_DATE + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT ," +
            KEY_SYNC_DATE + " TEXT," +
            KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_CFA_RETURN_PRODUCT_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_CFA_RETURN_PRODUCT_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_CFA_RETURN_PRODUCT_ID + " TEXT,"
            + KEY_CFA_RETURN_ID + " TEXT,"
            + KEY_PRODUCT_SKU_ID + " TEXT,"
            + KEY_STICKER_DETAILS_ID + " TEXT,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_RETAILER_SCANNED_OUT_STICKER = "CREATE TABLE IF NOT EXISTS "
            + TABLE_RETAILER_SCANNED_OUT_STICKER
            + "("
            + KEY_ID + " TEXT ,"
            + TOTALINSCANNED + " TEXT,"
            + DTMONTH + " TEXT)";

    /**
     * Update Login Display Name
     * id=A;
     * display_name=E;
     *
     * @param arrayCustomerDetails
     */
    public void updateLoginDetails(JSONArray arrayCustomerDetails, Context context) {
        try {
            String loginUserId=getLoginId();
            if (arrayCustomerDetails != null && arrayCustomerDetails.length() > 0) {
                for (int i = 0; i < arrayCustomerDetails.length(); i++) {
                    JSONObject objCustomer = arrayCustomerDetails.getJSONObject(i);
                    String userId = objCustomer.getString("A");
                    String displayName = objCustomer.getString("E");
//                    if (userId.equalsIgnoreCase(AppUtil.login_id)) {
                    if (userId.equalsIgnoreCase(loginUserId)) {
                        SQLiteDatabase db = writeDB();
//                        String sql = "Update login set var_personname='" + displayName + "' where fk_personGlcode='" + userId + "'";
                        String sql = "Update login set var_personname=? where fk_personGlcode='" + userId + "'";
                        String[] selectionArgs = {displayName};
                        db.rawQuery(sql,selectionArgs);
//                        db.execSQL(sql);
                        //BD
//                        Content.setPreferenceValue(context, Const.DISPLAY_NAME, displayName);
                        break;
                    }
                }
            }
        } catch (JSONException e) {
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = e.getMessage() + "In Method updateLoginDetails";
            e.printStackTrace();
        }
    }

    /**
     * Deleting All Tables of Damage
     */
    public void deleteDamageData() {
        SQLiteDatabase db = writeDB();
        db.execSQL("delete from " + DataBaseHelper.TABLE_CFA_DAMAGE);
        db.execSQL("delete from " + DataBaseHelper.TABLE_CFA_DAMAGE_PRODUCT);

        db.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_DAMAGE);
        db.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_DAMAGE_PRODUCT);

        db.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_DAMAGE);
        db.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_DAMAGE_PRODUCT);

//        db.close();
    }

    private static final String CREATE_TABLE_VIDEO_HELP = "CREATE TABLE IF NOT EXISTS " +
            TABLE_HELP_VIDEO_DETAIL +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            VIDEO_TYPE_DETAIL_ID + " INTEGER ," +
            VIDEO_TYPE_ID + " TEXT," +
            VIDEO_MENU_ID + " TEXT," +
            VIDEO_MENU_NAME + " TEXT," +
            ROLE_ID_IN_VIDEO + " TEXT," +
            VIDEO_FILE_NAME + " TEXT," +
            VIDEO_LOCAL_PATH + " TEXT," +
            VIDEO_UPLOAD_TYPE + " TEXT," +
            VIDEO_CUSTOMER_ID + " TEXT," +
            IS_DOWNLOADED + " INTEGER," +
            KEY_CREATE_ON + " TEXT," +
            KEY_MODIFIED_ON + " TEXT ," +
            KEY_SYNC_FLAG + " TEXT ," +
            KEY_SYNC_DATE + " TEXT ," +
            KEY_SYNC_USER + " TEXT ," +
            KEY_COUNTRY_ID + " TEXT ," +
            KEY_IMEI_NO + " TEXT )";


    private static final String CREATE_TABLE_MASTER_REASON = "CREATE TABLE IF NOT EXISTS " +
            TABLE_MASTER_REASON +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_REASON_ID + " INTEGER ," +
            KEY_REASON_NAME + " TEXT," +
            KEY_REASON_CODE + " TEXT," +
            KEY_USED_FOR_ID + " TEXT," +
            KEY_USED_FOR_CODE + " TEXT," +
            KEY_COUNTRY_ID + " TEXT," +
            KEY_DELETED + " TEXT," +
            KEY_STATUS + " TEXT," +
            KEY_CREATED_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " INTEGER," +
            KEY_CREATE_ON + " TEXT," +
            KEY_MODIFIED_ON + " TEXT )";

    private static final String CREATE_TABLE_SAVE_OFFLINE_LOG = "CREATE TABLE IF NOT EXISTS " +
            TABLE_SAVE_OFFLINE_LOG +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_USERID + " TEXT," +
            KEY_START_TIME + " TEXT," +
            KEY_END_TIME + " TEXT," +
            KEY_TOTAL_RECORDS_SAVED + " TEXT," +
            KEY_SAVE_DONE + " TEXT," +
            KEY_VERSION + " TEXT," +
            KEY_IMEINO + " TEXT," +
            KEY_CREATE_ON + " TEXT )";

    private static final String CREATE_TABLE_EXTRA_STICKER = "CREATE TABLE IF NOT EXISTS " +
            TABLE_EXTRA_STICKER + "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + EXTRA_STICKER_DETAIL_ID + " TEXT,"
            + EXTRA_STICKER_ID + " TEXT,"
            + BASE_BTC_NO_IN + " TEXT,"
            + BASE_BTC_NO_OUT + " TEXT,"
            + BASE_QR_CODE_IN + " TEXT,"
            + BASE_QR_CODE_OUT + " TEXT,"
            + KEY_BTC_NO_IN + " TEXT,"
            + BTC_NO_OUT + " TEXT,"
            + QR_CODE_IN + " TEXT,"
            + QR_CODE_OUT + " TEXT,"
            + STICKER_DETAIL_ID + " TEXT,"
            + MAPPED_ON + " TEXT,"
            + CREATE_BY_USER + " TEXT,"
            + CREATE_ON + " TEXT,"
            + SYNC_CODE + " TEXT,"
            + SYNC_FLAG + " TEXT,"
            + SYNC_DATE + " TEXT,"
            + SYNC_BY_USER + " TEXT,"
            + KEY_ANDROID_SYNC + " TEXT" + ")";

    private static final String CREATE_TABLE_EXTRA_STICKER_COPY = "CREATE TABLE IF NOT EXISTS " +
            TABLE_EXTRA_STICKER_COPY + "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + EXTRA_STICKER_DETAIL_ID + " TEXT,"
            + EXTRA_STICKER_ID + " TEXT,"
            + BASE_BTC_NO_IN + " TEXT,"
            + BASE_BTC_NO_OUT + " TEXT,"
            + BASE_QR_CODE_IN + " TEXT,"
            + BASE_QR_CODE_OUT + " TEXT,"
            + KEY_BTC_NO_IN + " TEXT,"
            + BTC_NO_OUT + " TEXT,"
            + QR_CODE_IN + " TEXT,"
            + QR_CODE_OUT + " TEXT,"
            + STICKER_DETAIL_ID + " TEXT,"
            + MAPPED_ON + " TEXT,"
            + CREATE_BY_USER + " TEXT,"
            + CREATE_ON + " TEXT,"
            + SYNC_CODE + " TEXT,"
            + SYNC_FLAG + " TEXT,"
            + SYNC_DATE + " TEXT,"
            + SYNC_BY_USER + " TEXT,"
            + KEY_ANDROID_SYNC + " TEXT" + ")";

    private static final String CREATE_TABLE_DEVICE_TOKEN = "CREATE TABLE IF NOT EXISTS "
            + TABLE_DEVICE_TOKEN
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_USER_ID + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + KEY_DEVICE_TOKEN + " TEXT)";

//    public String getLoginUserId() {
//        String loginId = "";
//        try {
//            SQLiteDatabase db = writeDB();
//            String sql = "Select fk_personGlcode from login";
//            Log.e("getLoginId", "" + sql);
//            Cursor cursor = db.rawQuery(sql, null);
//            try {
//                if (cursor != null && cursor.getCount() > 0) {
//                    while (cursor.moveToNext()) {
//                        loginId = cursor.getString(cursor.getColumnIndex("fk_personGlcode"));
//                    }
//                }
//            } catch (Exception e) {
//                e.printStackTrace();
//            } finally {
//                if (cursor != null) cursor.close();
//            }
//
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//        return loginId;
//    }

    public int getProductIdMaxId(String column, String table) {
        int pid = 0;
        SQLiteDatabase db = writeDB();
        try {
//            String sql = "Select max(" + column + ") AS maxid from " + table + ";";
            String sql = "SELECT MAX(CAST(" + column + " as INT))  AS maxid\n" +
                    "  FROM " + table + ";";
            Cursor cursor = db.rawQuery(sql, null);
            if (cursor != null && cursor.getCount() > 0) {
                cursor.moveToNext();
                pid = cursor.getInt(cursor.getColumnIndex("maxid")) + 1;
            }
            cursor.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return pid;
    }


    /**
     * Method to check if column Exists
     *
     * @param db
     * @param table
     * @param columnToCheck
     * @return
     */
    public static boolean columnExistsInTable(SQLiteDatabase db, String table, String columnToCheck) {
        Cursor cursor = null;
        try {
            //query a row. don't acquire db lock
            cursor = db.rawQuery("SELECT * FROM " + table + " LIMIT 0", null);

            // getColumnIndex()  will return the index of the column
            //in the table if it exists, otherwise it will return -1
            //great, the column exists
//sorry, the column does not exist
            return cursor.getColumnIndex(columnToCheck) != -1;

        } catch (SQLiteException Exp) {
            //Something went wrong with SQLite.
            //If the table exists and your query was good,
            //the problem is likely that the column doesn't exist in the table.
            return false;
        } finally {
            //close the db  if you no longer need it
//            if (db != null) db.close();
            //close the cursor
            if (cursor != null) cursor.close();
        }
    }

    /**
     * Updating Table Scanned Sticker
     *
     * @param objResponse
     * @param db
     */
    private void updateTableScannedStickers(JSONObject objResponse, SQLiteDatabase db, int isPoint, int isValid) {
        try {
            //isvalid 6 is for Sample And FOC
            ContentValues cv = new ContentValues();
            String barcodeNo = objResponse.getString("E") != null ? objResponse.getString("E") : objResponse.getString("F");

            if (isPoint == 3 && isValid == 1) {
                cv.put("isValid", "0");
            } else if (isValid == 2 || isValid == 5 || isValid == 6) {
                cv.put("isValid", "0");
            } else {
                cv.put("isValid", objResponse.getString("L"));
            }

            cv.put("sticker_details_id", objResponse.getString("D"));
            long id = db.update("table_scannedsticker", cv, "barcodeNo" + " =" + " '" + barcodeNo + "'", null);
            if (id > 0) {
                Log.e("TableScanned", "Update DONE");
            } else {
                Log.e("TableScanned", "Update Not DONE");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void deleteSaveOfflineLogTable() {
        try {
            SQLiteDatabase db = writeDB();
            db.execSQL("delete from " + DataBaseHelper.TABLE_SAVE_OFFLINE_LOG);
//            db.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }


    public String getCountryId() {
        String loginId = "";
        try {
            SQLiteDatabase db = writeDB();
            String sql = "Select country_id from login";
            Log.e("getLoginId", "" + sql);
            Cursor cursor = db.rawQuery(sql, null);
            if (cursor != null && cursor.getCount() > 0) {
                while (cursor.moveToNext()) {
                    loginId = cursor.getString(cursor.getColumnIndex("country_id"));
                }
            }
            if (cursor != null) cursor.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return loginId;
    }

    /**
     * Delete entry from Cfa Dispatch that
     * is not in bf_ishop_cfa_dispatch_product table
     */
    public void deleteCfaDispatchIDNotInProductTable() {
        SQLiteDatabase db = writeDB();
        String sql = "DELETE FROM bf_ishop_cfa_dispatch\n" +
                "      WHERE cfa_dispatch_id NOT IN (\n" +
                "    SELECT bidp.cfa_dispatch_id\n" +
                "      FROM bf_ishop_cfa_dispatch_product AS bidp\n" +
                ");";
        db.execSQL(sql);
//        db.close();
    }

    private static final String CREATE_TABLE_YELLOW_LABEL_DISCARD = "CREATE TABLE IF NOT EXISTS "
            + TABLE_YELLOW_LABEL_DISCARD
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_YELLOW_LABEL_DISCARD_ID + " INTEGER,"
            + KEY_CUSTOMER_ID + " TEXT,"
            + KEY_CUSTOMER_TYPE_COUNTRY_ID + " TEXT,"
            + KEY_DISCARD_DATE + " TEXT,"
            + KEY_IS_DISCARD + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_YELLOW_LABEL_DISCARD_DETAILS = "CREATE TABLE IF NOT EXISTS "
            + TABLE_YELLOW_LABEL_DISCARD_DETAILS
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_YELLOW_LABEL_DISCARD_PRODUCT_ID + " INTEGER,"
            + KEY_YELLOW_LABEL_DISCARD_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_ID + " INTEGER,"
            + KEY_STICKER_DETAILS_ID + " INTEGER,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";

    private static final String CREATE_TABLE_ISHOP_RETAILER_RETURN = "CREATE TABLE IF NOT EXISTS " +
            TABLE_ISHOP_RETAILER_RETURN + "(" + RETAILER_RETURN_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_CUSTOMER_FROM_ID + " INTEGER," +
            KEY_CUSTOMER_TO_ID + " INTEGER," +
            KEY_CUSTOMER_TYPE_COUNTRY_ID + " INTEGER," +
            IS_NEW_CUSTOMER + " INTEGER," +
            KEY_RETURN_DATE + " TEXT," +
            KEY_COUNTRY_ID + " TEXT," +
            KEY_CREATED_BY_USER + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT," +
            KEY_STATUS + " TEXT," +
            CREATE_ON + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            SYNC_CODE + " TEXT," +
            SYNC_FLAG + " TEXT," +
            SYNC_DATE + " TEXT," +
            SYNC_BY_USER + " TEXT" + ")";

    private static final String CREATE_TABLE_ISHOP_RETAILER_RETURN_PRODUCT = "CREATE TABLE IF NOT EXISTS " +
            TABLE_ISHOP_RETAILER_RETURN_PRODUCT + "(" + RETAILER_RETURN_PRODUCT_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            RETAILER_RETURN_ID + " INTEGER," +
            KEY_PRODUCT_SKU_ID + " INTEGER," +
            STICKER_DETAIL_ID + " INTEGER," +
            BTC_NO_OUT + " INTEGER," +
            QR_CODE_OUT + " TEXT," +
            KEY_QUANTITY + " TEXT," +
            KEY_AMOUNT + " TEXT," +
            KEY_UNIT + " TEXT," +
            KEY_QTY_KGL + " TEXT," +
            KEY_IS_VALID + " TEXT," +
            SYNC_CODE + " TEXT," +
            SYNC_FLAG + " TEXT," +
            SYNC_DATE + " TEXT," +
            SYNC_BY_USER + " TEXT" + ")";

    private static final String CREATE_TABLE_SALES_REP_INITIATED_PRODUCT_CURRENT_LIMIT = "CREATE TABLE IF NOT EXISTS " +
            TABLE_SALES_INITIATED_PRODUCT_CURRENT_LIMIT + "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_CUSTOMER_ID + " TEXT," +
            KEY_PRODUCT_SKU_COUNTRY_ID + " TEXT," +
            KEY_CURRENT_LIMIT + " TEXT" + ")";

    private static final String CREATE_TABLE_TRANSACTION_ERROR_LOG = "CREATE TABLE IF NOT EXISTS " +
            TABLE_TRANSACTION_ERROR_LOG + "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_PAGE_NAME + " TEXT," +
            KEY_METHOD_NAME + " TEXT," +
            KEY_USER_ID + " TEXT," +
            KEY_ERROR_MSG + " TEXT," +
            KEY_STACKTRACE + " TEXT," +
            KEY_MODULE_NAME + " TEXT," +
            KEY_SOURCE_SYSTEM + " TEXT," +
            KEY_ERROR_FORM + " TEXT," +
            KEY_EXTRA1 + " TEXT," +
            KEY_EXTRA2 + " TEXT," +
            KEY_ERROR_CODE + " TEXT," +
            KEY_ERROR_DATE + " TEXT," +
            KEY_SYNC_CODE + " TEXT," +
            KEY_SYNC_FLAG + " TEXT," +
            KEY_SYNC_DATE + " TEXT," +
            KEY_SYNC_USER + " TEXT," +
            KEY_SYNC_PROCESS_ID + " TEXT" + ")";

    private static final String CREATE_TABLE_ISHOP_PALLET_DETAIL = "CREATE TABLE IF NOT EXISTS " +
            DataBaseHelper.TABLE_ISHOP_PALLET_DETAILS + "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            Database_Column.KEY_PALLET_DETAIL_ID + " INTEGER," +
            Database_Column.KEY_STICKER_ID + " INTEGER," +
            Database_Column.KEY_PALLET_SERIAL_NO + " TEXT," +
            Database_Column.KEY_CUSTOMER_TYPE_COUNTRY_ID + " INTEGER," +
            Database_Column.KEY_CUSTOMER_ID + " INTEGER," +
            Database_Column.KEY_DELETED + " INTEGER," +
            Database_Column.KEY_IS_PARTIAL_DISPATCH + " INTEGER," +
            Database_Column.KEY_PARTIAL_DISPATCH_CUSTOMER_ID + " INTEGER," +
            Database_Column.KEY_PARTIAL_DISPATCH_DATE + " TEXT," +
            Database_Column.KEY_CREATED_BY_USER + " INTEGER," +
            Database_Column.KEY_CREATED_ON + " TEXT," +
            Database_Column.KEY_SYNC_CODE + " TEXT," +
            Database_Column.KEY_SYNC_FLAG + " TEXT," +
            Database_Column.KEY_SYNC_DATE + " TEXT," +
            Database_Column.KEY_SYNC_BY_USER + " TEXT," +
            Database_Column.KEY_ANDROID_SYNC + " TEXT," +
            Database_Column.KEY_IS_PALLET_SCAN + " INTEGER DEFAULT 0" + ")";

    private static final String CREATE_TABLE_ISHOP_PALLET_DETAIL_COPY = "CREATE TABLE IF NOT EXISTS " +
            DataBaseHelper.TABLE_ISHOP_PALLET_DETAILS_COPY + "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            Database_Column.KEY_PALLET_DETAIL_ID + " INTEGER," +
            Database_Column.KEY_STICKER_ID + " INTEGER," +
            Database_Column.KEY_PALLET_SERIAL_NO + " TEXT," +
            Database_Column.KEY_CUSTOMER_TYPE_COUNTRY_ID + " INTEGER," +
            Database_Column.KEY_CUSTOMER_ID + " INTEGER," +
            Database_Column.KEY_DELETED + " INTEGER," +
            Database_Column.KEY_IS_PARTIAL_DISPATCH + " INTEGER," +
            Database_Column.KEY_PARTIAL_DISPATCH_CUSTOMER_ID + " INTEGER," +
            Database_Column.KEY_PARTIAL_DISPATCH_DATE + " TEXT," +
            Database_Column.KEY_CREATED_BY_USER + " INTEGER," +
            Database_Column.KEY_CREATED_ON + " TEXT," +
            Database_Column.KEY_SYNC_CODE + " TEXT," +
            Database_Column.KEY_SYNC_FLAG + " TEXT," +
            Database_Column.KEY_SYNC_DATE + " TEXT," +
            Database_Column.KEY_SYNC_BY_USER + " TEXT," +
            Database_Column.KEY_ANDROID_SYNC + " TEXT," +
            Database_Column.KEY_IS_PALLET_SCAN + " INTEGER DEFAULT 0" + ")";

    /*Crete query for warehouse dispatch scm by jay */
    public static final String CREATE_TABLE_WARE_HOUSE_DISPATCH_SCM = "CREATE TABLE IF NOT EXISTS " +
            TABLE_DISPATCH_WAREHOUSE +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            SCM_CPM_ID + " int," +
            DO_STO_NO + " TEXT," +
            FROM_USER_ID + " TEXT," +
            TO_USER_ID + " TEXT," +
            TRUCK_NO + " TEXT," +
            SHIPMENT_STATUS + " TEXT," +
            ARTICLE_ID + " TEXT," +
            BATCH_NO + " TEXT," +
            DEC_QTY + " TEXT," +
            DELETED + " TEXT," +
            CREATED_BY_USER + " TEXT," +
            CREATED_ON + " TEXT," +
            MODIFIED_ON + " TEXT," +
            DEC_QTY_KGL + " TEXT)";

    public static final String CREATE_TABLE_WARE_HOUSE_DISPATCH_SCM_COPY = "CREATE TABLE IF NOT EXISTS " +
            TABLE_DISPATCH_WAREHOUSE_COPY +
            "(" + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            SCM_CPM_ID + " int," +
            DO_STO_NO + " TEXT," +
            FROM_USER_ID + " TEXT," +
            TO_USER_ID + " TEXT," +
            TRUCK_NO + " TEXT," +
            SHIPMENT_STATUS + " TEXT," +
            ARTICLE_ID + " TEXT," +
            BATCH_NO + " TEXT," +
            DEC_QTY + " TEXT," +
            DELETED + " TEXT," +
            CREATED_BY_USER + " TEXT," +
            CREATED_ON + " TEXT," +
            MODIFIED_ON + " TEXT," +
            DEC_QTY_KGL + " TEXT)";

    private static final String CREATE_TABLE_STICKER_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_STICKER_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_STICKER_ID + " TEXT,"
            + KEY_REF_ID + " TEXT,"
            + KEY_SYSTEM_CODE + " TEXT,"
            + KEY_TOLLER_CODE + " TEXT,"
            + KEY_CUSTOMER_ID + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_PRODUCTION_DATE + " TEXT,"
            + KEY_PBG_COUNTRY_ID + " TEXT,"
            + KEY_PRODUCT_SKU_COUNTRY_ID + " TEXT,"
            + KEY_BATCH_NO + " TEXT,"
            + KEY_BATCH_ID + " INTEGER,"
            + KEY_MFG_DATE + " TEXT,"
            + KEY_EXPIRE_DATE + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_BUFFER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_DRAFT + " TEXT,"
            + KEY_DRAFT_DATE + " TEXT,"
            + KEY_DRAFT_REASON + " TEXT,"
            + KEY_DELETED + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT)";


    private static final String CREATE_TABLE_EMPLOYEE_DETAILS = "CREATE TABLE IF NOT EXISTS "
            + TABLE_EMPLOYEE_DETAILS
            + "("
            + KEY_ID + " TEXT ,"
            + KEY_EMAIL + " TEXT,"
            + KEY_USER_CODE + " TEXT,"
            + KEY_BUSSINESS_CODE + " TEXT,"
            + KEY_DISPLAY_NAME + " TEXT,"
            + KEY_POLITICAL_GEO_ID + " TEXT,"
            + KEY_political_geography_countrylevel_id + " TEXT,"
            + KEY_political_regional_level + " TEXT,"
            + KEY_EMPLOYEE_TYPE_REGIONAL_LEVEL + " TEXT,"
            + KEY_PRIMARY_MOBILE_NO + " TEXT)";

    private static final String DATABASE_CREATE_TABLE_POLITICAL_DETAILS_EMP = "CREATE TABLE IF NOT EXISTS " +
            TABLE_POLITICAL_DETAILS_EMP + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + KEY_POLITICAL_GEO_ID + " TEXT,"
            + KEY_GEO_LEVEL_ID + " TEXT,"
            + KEY_PARENT_GEO_ID + " TEXT,"
            + KEY_POLITICAL_GEOGRAPHY_CODE + " TEXT,"
            + KEY_POLITICAL_GEOGRAPHY_NAME + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFICATION_BY_USER + " TEXT,"
            + KEY_DELETED + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT"
            + ")";

    private static final String CREATE_TABLE_SAMPLE_DISPATCH = "CREATE TABLE IF NOT EXISTS "
            + TABLE_ISHOP_SAMPLE_DISPATCH
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + COL_SAMPLE_DISPATCH_ID + " INTEGER,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_SAP_ID + " TEXT,"
            + KEY_DISPATCH_TYPE + " TEXT,"
            + KEY_DOC_NO + " TEXT,"
            + KEY_DISPATCH_DATE + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + KEY_IS_DISPATCH + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + IS_DISPATCH_TYPE + " INTEGER DEFAULT 0)";

    private static final String CREATE_TABLE_SAMPLE_DISPATCH_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_ISHOP_SAMPLE_DISPATCH_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + COL_SAMPLE_DISPATCH_ID + " INTEGER,"
            + KEY_CUSTOMER_FROM_ID + " TEXT,"
            + KEY_CUSTOMER_TO_ID + " TEXT,"
            + KEY_SAP_ID + " TEXT,"
            + KEY_DISPATCH_TYPE + " TEXT,"
            + KEY_DOC_NO + " TEXT,"
            + KEY_DISPATCH_DATE + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + KEY_IS_DISPATCH + " TEXT,"
            + KEY_COUNTRY_ID + " TEXT,"
            + KEY_CREATED_BY_USER + " TEXT,"
            + KEY_MODIFIED_BY_USER + " TEXT,"
            + KEY_STATUS + " TEXT,"
            + KEY_CREATE_ON + " TEXT,"
            + KEY_MODIFIED_ON + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + IS_DISPATCH_TYPE + " INTEGER DEFAULT 0)";

    private static final String CREATE_TABLE_SAMPLE_DISPATCH_PRODUCT = "CREATE TABLE IF NOT EXISTS "
            + TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + COL_SAMPLE_DISPATCH_PRODUCT_ID + " INTEGER,"
            + COL_SAMPLE_DISPATCH_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_ID + " INTEGER,"
            + KEY_STICKER_DETAILS_ID + " INTEGER,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + DISPATCH_SCAN_TYPE + " TEXT )";

    private static final String CREATE_TABLE_SAMPLE_DISPATCH_PRODUCT_COPY = "CREATE TABLE IF NOT EXISTS "
            + TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT_COPY
            + "("
            + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT,"
            + COL_SAMPLE_DISPATCH_PRODUCT_ID + " INTEGER,"
            + COL_SAMPLE_DISPATCH_ID + " INTEGER,"
            + KEY_PRODUCT_SKU_ID + " INTEGER,"
            + KEY_STICKER_DETAILS_ID + " INTEGER,"
            + KEY_BTC_NO_OUT + " TEXT,"
            + KEY_QR_CODE_OUT + " TEXT,"
            + KEY_QUANTITY + " TEXT,"
            + KEY_AMOUNT + " TEXT,"
            + KEY_UNIT + " TEXT,"
            + KEY_QTY_KGL + " TEXT,"
            + KEY_IS_VALID + " TEXT,"
            + KEY_RECEIVED + " TEXT,"
            + KEY_RECEIVED_DATE + " TEXT,"
            + KEY_SYNC_CODE + " TEXT,"
            + KEY_SYNC_FLAG + " TEXT ,"
            + KEY_SYNC_DATE + " TEXT,"
            + KEY_SYNC_USER + " TEXT,"
            + DISPATCH_SCAN_TYPE + " TEXT )";

    private static final String CREATE_TABLE_EVOUCHER_SCAN = "CREATE TABLE IF NOT EXISTS "
            + TABLE_EVOUCHER_SCAN
            + "(" +
            KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT ," +
            KEY_REDEMPTION_DETAIL_ID + " TEXT ," +
            STICKER_DETAIL_ID + " TEXT ," +
            KEY_BTC_NO + " TEXT ," +
            KEY_SKU_COUNTRY_ID + " TEXT ," +
            KEY_QTY_KGL + " TEXT ," +
            KEY_IS_VALID + " TEXT ," +
            CREATED_ON + " TEXT)";

    private static final String CREATE_TABLE_MASTER_CONVERSION = "CREATE TABLE IF NOT EXISTS "
            + TABLE_MASTER_CONVERSION
            + "(" +
            KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT ," +
            KEY_CONVERSION_ID + " TEXT ," +
            KEY_PRODUCT_SKU_ID_CONVERSION + " TEXT ," +
            KEY_SKU_CONVERSION_FACTOR + " TEXT ," +
            KEY_BOX_CONVERSION_FACTOR + " TEXT)";

    private static final String CREATE_TABLE_SKU_WISE_BLOCKING_DETAILS = "CREATE TABLE IF NOT EXISTS "
            + TABLE_SKU_WISE_BLOCKING
            + "(" +
            KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT ," +
            KEY_INT_ID + " TEXT ," +
            KEY_PBG_ID_BLOCK + " TEXT ," +
            KEY_SKU_ID + " TEXT ," +
            KEY_NO_OF_MONTH + " TEXT ," +
            KEY_BLOCK_SCANNING_CODE + " TEXT ," +
            KEY_BLOCK_SCANNING_BY + " TEXT ," +
            KEY_CREATED_BY_USER + " TEXT ," +
            KEY_CREATE_ON + " TEXT ," +
            KEY_MODIFIED_BY_USER + " TEXT ," +
            KEY_MODIFIED_ON + " TEXT)";

    private static final String CREATE_TABLE_LOOKUP_VALUES_CONFIG = "CREATE TABLE IF NOT EXISTS "
            + TABLE_BLOCKING_LOOKUP_VALUES
            + "(" +
            KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT ," +
            KEY_LOOKUP_TYPE_ID + " TEXT ," +
            KEY_LOOKUP_CODE + " TEXT ," +
            KEY_LOOKUP_VALUE + " TEXT)";

    private static final String CREATE_TABLE_B2C_CONFIG = "CREATE TABLE  " + B2C_CONFIG_TABLE + "(" +
            INTGLCODE + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_IS_B2C + " TEXT," +
            KEY_CONFIG_ID + " TEXT," +
            KEY_CONFIG_CODE + " TEXT," +
            KEY_TENANT + " TEXT," +
            KEY_POLICY + " TEXT," +
            KEY_CLIENT_ID + " TEXT," +
            KEY_SCOPE + " TEXT," +
            KEY_CLIENT_SECRET_KEY + " TEXT," +
            KEY_PLATFORM + " TEXT," +
            KEY_METHOD + " TEXT," +
            KEY_CERTIFICATE_FILE + " TEXT," +
            KEY_FILE + " TEXT," +
            KEY_APPLICATION_TYPE + " TEXT," +
            KEY_COUNTRY_ID + " TEXT)";

    private static final String CREATE_TABLE_B2C_LOGIN_LOG = "CREATE TABLE  " + B2C_LOG_DETAILS + "(" +
            KEY_LOG_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_REQUEST_URL + " TEXT," +
            KEY_REQUEST_PARAM + " TEXT," +
            KEY_REQUEST_MESSAGE + " TEXT," +
            KEY_HEADER + " TEXT," +
            KEY_RESPONSE + " TEXT," +
            KEY_CODE + " TEXT," +
            KEY_RESPONSE_STATUS + " TEXT," +
            KEY_PLATFORM_TYPE + " TEXT," +
            KEY_START_TIME_LOG + " TEXT," +
            KEY_END_TIME__LOG + " TEXT," +
            KEY_COUNTRY_ID + " TEXT," +
            KEY_STATUS + " TEXT," +
            KEY_DELETED + " TEXT," +
            KEY_CREATE_ON + " TEXT," +
            KEY_CREATED_BY_USER + " TEXT," +
            KEY_MODIFIED_ON + " TEXT," +
            KEY_MODIFIED_BY_USER + " TEXT)";

    private static final String CREATE_TABLE_B2C_LOGIN = "CREATE TABLE  " + B2C_LOGIN + "(" +
            KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
            KEY_PHONE_NUMBER + " TEXT," +
            KEY_ACCESSTOKEN + " TEXT," +
            KEY_ID_TOKEN + " TEXT," +
            KEY_REFRESH_TOKEN + " TEXT," +
            KEY_CLIENT_ID + " TEXT," +
            KEY_POLICY + " TEXT," +
            KEY_COUNTRY_CODE_B2C + " TEXT," +
            KEY_TOKEN_EXPIRY + " TEXT," +
            KEY_SUB + " TEXT)";

}
