package ecp.vcs.com.ecpsyncplugin.re_sync.utils;

import android.content.Context;
import android.content.SharedPreferences;

/**
 * Created by vcsdev0131 on 11/20/2017.
 */

public class SharedPreferenceHelper {
    private final static String PREF_FILE = "PREF";

    public final static String DEVICE_TOKEN = "DEVICE_TOKEN";
    public final static String SYNC_SESSION = "SYNC_SESSION";
    public final static String LAST_SYNC_DATE_TIME = "LAST_SYNC_DATE_TIME";
    public final static String TRENDING_PRODUCT = "TRENDING_PRODUCT";
    public final static String IS_ALARM_ACTIVE = "IS_ALARM_ACTIVE";
    public final static String IS_SCAN_ALARM_ACTIVE = "IS_SCAN_ALARM_ACTIVE";
    public final static String REGISTRATION_DETAILS = "REGISTRATION_DETAILS";
    public final static String TICKER_DETAILS = "TICKER_DETAILS";

    public final static String CUSTOMER_NAME = "customer_name";
    public final static String IS_FROM = "dispatch_type";
    public final static String EARNED_VALUE = "earned_value";

    /**
     * Set a string shared preference
     * @param key - Key to set shared preference
     * @param value - Value for the key
     */
    public static void setString(Context context, String key, String value){
        SharedPreferences settings = context.getSharedPreferences(PREF_FILE, 0);
        SharedPreferences.Editor editor = settings.edit();
        editor.putString(key, value);
        editor.apply();
    }

    /**
     * Set a integer shared preference
     * @param key - Key to set shared preference
     * @param value - Value for the key
     */
    public static void setInt(Context context, String key, int value){
        SharedPreferences settings = context.getSharedPreferences(PREF_FILE, 0);
        SharedPreferences.Editor editor = settings.edit();
        editor.putInt(key, value);
        editor.apply();
    }

    /**
     * Set a Boolean shared preference
     * @param key - Key to set shared preference
     * @param value - Value for the key
     */
    public static void setBoolean(Context context, String key, boolean value){
        SharedPreferences settings = context.getSharedPreferences(PREF_FILE, 0);
        SharedPreferences.Editor editor = settings.edit();
        editor.putBoolean(key, value);
        editor.apply();
    }

    /**
     * Get a string shared preference
     * @param key - Key to look up in shared preferences.
     * @return value - String containing value of the shared preference if found.
     */
    public static String getString(Context context, String key){
        SharedPreferences settings = context.getSharedPreferences(PREF_FILE, 0);
        return settings.getString(key, "");
    }

    /**
     * Get a integer shared preference
     * @param key - Key to look up in shared preferences.
     * @return value - String containing value of the shared preference if found.
     */
    public static int getInt(Context context, String key){
        SharedPreferences settings = context.getSharedPreferences(PREF_FILE, 0);
        return settings.getInt(key, 0);
    }

    /**
     * Get a boolean shared preference
     * @param key - Key to look up in shared preferences.
     * @return value - String containing value of the shared preference if found.
     */
    public static boolean getBoolean(Context context, String key){
        SharedPreferences settings = context.getSharedPreferences(PREF_FILE, 0);
        return settings.getBoolean(key, false);
    }
}
