package ecp.vcs.com.ecpsyncplugin.re_sync.database;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;
import android.util.Log;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import ecp.vcs.com.ecpsyncplugin.R;
import ecp.vcs.com.ecpsyncplugin.re_sync.aesCipher.AESCipher;
import ecp.vcs.com.ecpsyncplugin.re_sync.logging.LogHelper;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.BarcodeModel;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CityModel;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CustomerDetail;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.DistributorReceivedProduct;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopDistributorDispatch;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.ProductDetails;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.SalesRepInitiatedProduct;
import ecp.vcs.com.ecpsyncplugin.re_sync.networking.AppUtil;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.Const;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.Content;

public class DatabaseHelperExtended extends DataBaseHelper {


    private final Context context;
    public static final String KEY_CURRENT_LIMIT = "current_limit";

    public DatabaseHelperExtended(Context context) {
        super(context);
        this.context = context;
    }

    /**
     * Inserting Retailer Return Product Table after Check Online for Retailer Return
     *
     * @param arrayRetailerReturnProduct
     */
    public void insertRetailerReturnProduct(JSONArray arrayRetailerReturnProduct) {
        SQLiteDatabase database = writeDB();
        database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_RETURN_PRODUCT + " WHERE sync_flag='Y'");
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_RETAILER_RETURN_PRODUCT
                    + " (" + DataBaseHelper.KEY_RETAILER_RETURN_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_RETAILER_RETURN_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            for (int k = 0; k < arrayRetailerReturnProduct.length(); k++) {
                JSONObject object;
                try {
                    object = arrayRetailerReturnProduct.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//retailer_return_product_id
                    statement.bindString(2, object.getString("B"));//retailer_return_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("F"));//qr_code_out
                    statement.bindString(7, object.getString("G"));//quantity
                    statement.bindString(8, object.getString("H"));//amount
                    statement.bindString(9, object.getString("I"));//unit
                    statement.bindString(10, object.getString("J"));//qty_kgl
                    statement.bindString(11, object.getString("K"));//is_valid
                    statement.bindString(12, object.getString("L"));//sync_code
                    statement.bindString(13, "Y");//sync_flag
                    statement.bindString(14, object.getString("N"));//sync_date
                    statement.bindString(15, object.getString("O"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                }

            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } finally {
            database.endTransaction();
        }

    }

    /*Todo******************* change by praveen *******************************/
    public void updateRetailerReceiveProductSyncFlag() {
        SQLiteDatabase database = writeDB();
        ContentValues cv = new ContentValues();
        cv.put(DataBaseHelper.KEY_SYNC_FLAG, "N");
        long id = database.update(DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT, cv, "sync_flag='Y'", null);
        if (id > 0) {
            Log.e("updateRetiler_recieve", "done");
        } else {
            Log.e("updateRetiler_recieve", "not done");
        }
        database.close();
    }

    public String getCustomerTypeCountryId(String loginId) {
        String customerTypeCountryID = "";
        try {
            SQLiteDatabase db = writeDB();
            String sql = "Select customer_type_country_id from customer_details WHERE id ='" + loginId + "'";
            Log.e("getLoginId", "" + sql);
            Cursor cursor = db.rawQuery(sql, null);
            if (cursor != null && cursor.getCount() > 0) {
                while (cursor.moveToNext()) {
                    customerTypeCountryID = cursor.getString(cursor.getColumnIndex("customer_type_country_id"));
                }
            }
            if (cursor != null) cursor.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return customerTypeCountryID;
    }

    /*Todo******************* change by praveen *******************************/
    public void updateRetailerDispatchProductSyncFlag() {
        SQLiteDatabase database = writeDB();
        ContentValues cv = new ContentValues();
        cv.put(DataBaseHelper.KEY_SYNC_FLAG, "N");
        long id = database.update("bf_ishop_retailer_dispatch_product", cv, "sync_flag='Y'", null);
        if (id > 0) {
            Log.e("updateRetiler_dispatch", "done");
        } else {
            Log.e("updateRetiler_dispatch", "not done");
        }
        database.close();
    }

    public void insertValidInvalidCodesRetailerReceive(String insertValue) {
        try {
            SQLiteDatabase db = writeDB();

            String sql = "INSERT INTO " + DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT
                    + " (" + DataBaseHelper.RETAILER_RECEIVED_PRODUCT_ID + ","
                    + DataBaseHelper.RETAILER_RECEIVED_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_CREATE_BY + ","
                    + DataBaseHelper.KEY_RECEIVE_SCAN_TYPE + " ) VALUES " + insertValue;

            db.execSQL(sql);
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public ArrayList<DistributorReceivedProduct> getRetailerReceivedProductDAta(String customerId, String
            date, String keyUserId) {
        ArrayList<DistributorReceivedProduct> list = new ArrayList<>();
        SQLiteDatabase db = writeDB();
        String qry = "    SELECT biddp.product_sku_id,\n" +
                "           biddp.sticker_details_id,\n" +
                "           biddp.btc_no_out,\n" +
                "           biddp.qr_code_out,\n" +
                "           biddp.quantity,\n" +
                "           biddp.amount,\n" +
                "           biddp.unit,\n" +
                "           biddp.qty_kgl,\n" +
                "           biddp.is_valid\n" +
                "           \n" +
                "      FROM bf_ishop_distributor_dispatch AS bisdd\n" +
                "           INNER JOIN bf_ishop_distributor_dispatch_product AS biddp\n" +
                "                   ON bisdd.distributor_dispatch_id = biddp.distributor_dispatch_id\n" +
                "           INNER JOIN customer_details AS CD\n" +
                "                   ON CD.id = bisdd.customer_from_id\n" +
                "           INNER JOIN product_sku_country AS mpsc\n" +
                "                   ON mpsc.product_sku_country_id = biddp.product_sku_id\n" +
                "     WHERE ( ifnull( biddp.received, 0 ) = 0 \n" +
                "               OR\n" +
                "           biddp.received = '' ) \n" +
                "           AND\n" +
                "           datetime( bisdd.dispatch_date ) = datetime( '" + date + "' )  \n" +
                "           AND\n" +
                "           bisdd.customer_from_id = " + customerId + " \n" +
                "           AND\n" +
                "           bisdd.customer_to_id = " + keyUserId + "\n" +
                "    UNION ALL\n" +
                "    SELECT birdp.product_sku_id,\n" +
                "           birdp.sticker_details_id,\n" +
                "           birdp.btc_no as btc_no_out,\n" +
                "           birdp.qr_code as qr_code_out,\n" +
                "           birdp.quantity,\n" +
                "           birdp.amount,\n" +
                "           birdp.unit,\n" +
                "           birdp.qty_kgl,\n" +
                "           birdp.is_valid\n" +
                "      FROM bf_ishop_retailer_dispatch AS bird\n" +
                "           INNER JOIN bf_ishop_retailer_dispatch_product AS birdp\n" +
                "                   ON bird.retailer_dispatch_id = birdp.retailer_dispatch_id\n" +
                "           INNER JOIN customer_details AS CD\n" +
                "                   ON CD.id = bird.customer_from_id\n" +
                "           INNER JOIN product_sku_country AS mpsc\n" +
                "                   ON mpsc.product_sku_country_id = birdp.product_sku_id\n" +
                "     WHERE ( ifnull( birdp.received, 0 ) = 0 \n" +
                "               OR\n" +
                "           birdp.received = '' ) \n" +
                "           AND\n" +
                "           datetime( bird.dispatch_date ) = datetime( '" + date + "' )  \n" +
                "           AND\n" +
                "           bird.customer_from_id = " + customerId + " \n" +
                "           AND\n" +
                "           bird.customer_to_id = " + keyUserId + ";";

        Log.e("qry--", ">>" + qry);
        Cursor cursor = db.rawQuery(qry, null);
        if (cursor != null && cursor.getCount() > 0) {
            while (cursor.moveToNext()) {
                DistributorReceivedProduct model = new DistributorReceivedProduct();
                model.setProduct_sku_id(cursor.getInt(cursor.getColumnIndex("product_sku_id")));
                model.setSticker_details_id(cursor.getInt(cursor.getColumnIndex("sticker_details_id")));
                model.setBtc_no_out(cursor.getString(cursor.getColumnIndex("btc_no_out")));
                model.setQr_code_out(cursor.getString(cursor.getColumnIndex("qr_code_out")));
                model.setQuantity(cursor.getString(cursor.getColumnIndex("quantity")));
                model.setAmount(cursor.getString(cursor.getColumnIndex("amount")));
                model.setUnit(cursor.getString(cursor.getColumnIndex("unit")));
                model.setQty_kgl(cursor.getString(cursor.getColumnIndex("qty_kgl")));
                model.setIs_valid(cursor.getString(cursor.getColumnIndex("is_valid")));
                //model.setSync_code(cursor.getString(cursor.getColumnIndex("sync_code")));
                list.add(model);
            }
        }
        if (cursor != null) cursor.close();
        return list;
    }

    /**
     * Making isvalid 3 when isvalid is 0 when Dist First Sell to farmer and Confirm
     * And then Try to Dispatch it to Retailer for Check Online
     *
     * @param
     */
    public void updateDispatchedStickerDispatchDistDSTypeCheckOnline(boolean sellToFarmer) {
        SQLiteDatabase db = writeDB();

        String sql = "UPDATE bf_ishop_distributor_dispatch_product\n" +
                "   SET is_valid = '3'\n" +
                " WHERE btc_no_out IN (\n" +
                "           SELECT DISTINCT ts.barcodeNo\n" +
                "             FROM ishop_sticker_details AS isd\n" +
                "                  INNER JOIN\n" +
                "                  bf_ishop_distributor_dispatch_product AS birdp ON (birdp.btc_no_out = isd.btc_no_out OR birdp.btc_no_out = isd.btc_no_in)\n" +
                "                  INNER JOIN\n" +
                "                  bf_ishop_distributor_dispatch AS bird ON bird.distributor_dispatch_id = birdp.distributor_dispatch_id\n" +
                "                  INNER JOIN\n" +
                "                  table_scannedsticker AS ts ON (ts.barcodeNo = isd.btc_no_in) OR \n" +
                "                                                (ts.barcodeNo = isd.btc_no_out) \n" +
                "            WHERE (ts.barcodeNo = isd.btc_no_out AND \n" +
                "                   birdp.is_valid = '1') OR \n" +
                "                  (ts.barcodeNo = isd.btc_no_in AND \n" +
                "                   birdp.is_valid = '1') \n" +
                "       )\n" +
                "AND \n" +
                "       is_valid = '0' OR \n" +
                "       is_valid = '2';\n";
        db.execSQL(sql);

//        String sql1 = "UPDATE bf_ishop_distributor_dispatch_product\n" +
//                "   SET is_valid = '3'\n" +
//                " WHERE btc_no_out IN (\n" +
//                "           SELECT DISTINCT ts.barcodeNo\n" +
//                "             FROM ishop_sticker_details AS isd\n" +
//                "                  INNER JOIN\n" +
//                "                  bf_ishop_distributor_return_request_product AS birdp ON birdp.btc_no_out = isd.btc_no_out OR \n" +
//                "                                                                          birdp.btc_no_out = isd.btc_no_in\n" +
//                "                  INNER JOIN\n" +
//                "                  bf_ishop_distributor_return_request AS bird ON bird.distributor_return_request_id = birdp.distributor_return_request_id\n" +
//                "                  INNER JOIN\n" +
//                "                  table_scannedsticker AS ts ON (ts.barcodeNo = isd.btc_no_in) OR \n" +
//                "                                                (ts.barcodeNo = isd.btc_no_out) \n" +
//                "            WHERE birdp.is_valid = '1' AND \n" +
//                "                  ifnull(birdp.received,'0') <> '1'\n" +
//                "       )\n" +
//                "AND \n" +
//                "       is_valid = '0' OR \n" +
//                "       is_valid = '2';";
//        db.execSQL(sql1);


//        String sql1 = "UPDATE bf_ishop_distributor_dispatch_product\n" +
//                "   SET is_valid = '5'\n" +
//                " WHERE btc_no_out IN (\n" +
//                "           SELECT DISTINCT ts.barcodeNo\n" +
//                "             FROM ishop_sticker_details AS isd\n" +
//                "                  INNER JOIN\n" +
//                "                  bf_ishop_distributor_return_request_product AS birdp ON birdp.btc_no_out = isd.btc_no_out OR \n" +
//                "                                                                          birdp.btc_no_out = isd.btc_no_in\n" +
//                "                  INNER JOIN\n" +
//                "                  bf_ishop_distributor_return_request AS bird ON bird.distributor_return_request_id = birdp.distributor_return_request_id\n" +
//                "                  INNER JOIN\n" +
//                "                  table_scannedsticker AS ts ON (ts.barcodeNo = isd.btc_no_in) OR \n" +
//                "                                                (ts.barcodeNo = isd.btc_no_out) \n" +
//                "            WHERE birdp.is_valid = '1' AND \n" +
//                "                  ifnull(birdp.received,'0') <> '1'\n" +
//                "       )\n" +
//                "AND \n" +
//                "       is_valid = '0' OR \n" +
//                "       is_valid = '2';";
//        db.execSQL(sql1);

        String sql1 = "UPDATE bf_ishop_distributor_dispatch_product\n" +
                "   SET is_valid = '3'\n" +
                " WHERE btc_no_out IN (\n" +
                "           SELECT DISTINCT ts.barcodeNo\n" +
                "             FROM ishop_sticker_details AS isd\n" +
                "                  INNER JOIN\n" +
                "                  bf_ishop_distributor_return_request_product AS birdp ON birdp.btc_no_out = isd.btc_no_out OR \n" +
                "                                                                          birdp.btc_no_out = isd.btc_no_in\n" +
                "                  INNER JOIN\n" +
                "                  bf_ishop_distributor_return_request AS bird ON bird.distributor_return_request_id = birdp.distributor_return_request_id\n" +
                "                  INNER JOIN\n" +
                "                  table_scannedsticker AS ts ON (ts.barcodeNo = isd.btc_no_in) OR \n" +
                "                                                (ts.barcodeNo = isd.btc_no_out) \n" +
                "            WHERE birdp.is_valid = '1' AND \n" +
                "                  ifnull(birdp.received,'0') <> '1'\n" +
                "       )\n" +
                "AND \n" +
                "       is_valid = '0' OR \n" +
                "       is_valid = '2';";
        db.execSQL(sql1);

        String sql2 = "UPDATE bf_ishop_distributor_dispatch_product\n" +
                "   SET is_valid = '3'\n" +
                " WHERE btc_no_out IN (\n" +
                "           SELECT DISTINCT ts.barcodeNo\n" +
                "             FROM ishop_sticker_details AS isd\n" +
                "                  INNER JOIN\n" +
                "                  bf_ishop_distributor_damage_product AS birdp ON birdp.btc_no_out = isd.btc_no_out OR \n" +
                "                                                                  birdp.btc_no_out = isd.btc_no_in\n" +
                "                  INNER JOIN\n" +
                "                  bf_ishop_distributor_damage AS bird ON bird.distributor_damage_id = birdp.distributor_damage_id\n" +
                "                  INNER JOIN\n" +
                "                  table_scannedsticker AS ts ON (ts.barcodeNo = isd.btc_no_in) OR \n" +
                "                                                (ts.barcodeNo = isd.btc_no_out) \n" +
                "            WHERE birdp.is_valid = '1'\n" +
                "       )\n" +
                "AND \n" +
                "       is_valid = '0' OR \n" +
                "       is_valid = '2';\n";
        db.execSQL(sql2);
    }


    public void deleteDistributorReturnRequestData(String customerId) {
        SQLiteDatabase db = writeDB();
        String sql = "DELETE FROM bf_ishop_distributor_return_request_product\n" +
                "      WHERE sticker_details_id IN (\n" +
                "    SELECT bicrp.sticker_details_id\n" +
                "      FROM bf_ishop_cfa_return_product AS bicrp\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_cfa_return AS bicr ON bicr.cfa_return_id = bicrp.cfa_return_id\n" +
                "           INNER JOIN\n" +
                "           ishop_sticker_details AS isd ON isd.sticker_details_id = bicrp.sticker_details_id\n" +
                "           INNER JOIN\n" +
                "           CustomerType_Details AS ctd ON ctd.customer_type_country_id = isd.customer_type_country_id\n" +
                "     WHERE bicr.isDispatch = '1' AND \n" +
                "           bicrp.is_valid = '1' AND \n" +
                "           ctd.customer_level = 'L3' AND bicr.customer_to_id='" + customerId + "' \n" +
                ");";
        db.execSQL(sql);
        db.close();
    }

    public static void onUpgradeBaseURL(Context context) {
        try {
//            new UpdateAppData(context).execute();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String getLoginPassword() {
        String loginId = "";
        try {
            SQLiteDatabase db = writeDB();
            String sql = "Select var_password from login";
            Log.e("getLoginId", "" + sql);
            Cursor cursor = db.rawQuery(sql, null);
            if (cursor != null && cursor.getCount() > 0) {
                while (cursor.moveToNext()) {
                    loginId = cursor.getString(cursor.getColumnIndex("var_password"));
                }
            }
            if (cursor != null) cursor.close();

        } catch (Exception e) {
            e.printStackTrace();
        }
        return loginId;
    }

    public void updateIsValid2ifAlreadyScanned(boolean isDetailScan, boolean isNewRetailer) {
        SQLiteDatabase db = writeDB();

        String sql = "UPDATE table_scannedsticker\n" +
                "   SET isValid = '2'\n" +
                " WHERE sticker_details_id IN (\n" +
                "    SELECT DISTINCT ts.sticker_details_id\n" +
                "      FROM bf_ishop_distributor_dispatch_product AS biddp\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_distributor_dispatch AS bidd ON biddp.distributor_dispatch_id = bidd.distributor_dispatch_id\n" +
                "           INNER JOIN\n" +
                "           table_scannedsticker ts ON ts.barcodeNo = biddp.btc_no_out\n" +
                "     WHERE biddp.sync_flag = 'Y' AND \n" +
                "           bidd.isDispatch = '1' AND \n" +
                "           ts.barcodeNo IS NOT NULL\n" +
                ");\n";
        db.execSQL(sql);

        String sql1;
        if (isDetailScan) {
            if (isNewRetailer) {
                sql1 = "UPDATE bf_ishop_distributor_dispatch_product\n" +
                        "   SET is_valid = '3'\n" +
                        " WHERE sticker_details_id IN (\n" +
                        "           SELECT ts.sticker_details_id\n" +
                        "             FROM bf_ishop_distributor_dispatch_product AS biddp\n" +
                        "                  INNER JOIN\n" +
                        "                  bf_ishop_distributor_dispatch AS bidd ON biddp.distributor_dispatch_id = bidd.distributor_dispatch_id\n" +
                        "                  INNER JOIN\n" +
                        "                  table_scannedsticker ts ON ts.barcodeNo = biddp.btc_no_out\n" +
                        "            WHERE (biddp.is_valid = '1' OR \n" +
                        "                   biddp.is_valid = '2') AND \n" +
                        "                  ts.barcodeNo IS NOT NULL\n" +
                        "       )\n" +
                        "AND \n" +
                        "       (is_valid = '0' OR \n" +
                        "        is_valid = '2');\n";
            } else {
                sql1 = "UPDATE bf_ishop_distributor_dispatch_product\n" +
                        "   SET is_valid = '3'\n" +
                        " WHERE sticker_details_id IN (\n" +
                        "           SELECT ts.sticker_details_id\n" +
                        "             FROM bf_ishop_distributor_dispatch_product AS biddp\n" +
                        "                  INNER JOIN\n" +
                        "                  bf_ishop_distributor_dispatch AS bidd ON biddp.distributor_dispatch_id = bidd.distributor_dispatch_id\n" +
                        "                  INNER JOIN\n" +
                        "                  table_scannedsticker ts ON ts.barcodeNo = biddp.btc_no_out\n" +
                        "            WHERE (biddp.is_valid = '1' OR \n" +
                        "                   biddp.is_valid = '2') AND \n" +
                        "                  ts.barcodeNo IS NOT NULL\n" +
                        "       )\n" +
                        "AND \n" +
                        "       (is_valid = '0' OR \n" +
                        "        is_valid = '2');\n";
            }
        } else {
//            For Basic Scan
            sql1 = "UPDATE bf_ishop_distributor_dispatch_product\n" +
                    "   SET is_valid = '3'\n" +
                    " WHERE sticker_details_id IN (\n" +
                    "           SELECT ts.sticker_details_id\n" +
                    "             FROM bf_ishop_distributor_dispatch_product AS biddp\n" +
                    "                  INNER JOIN\n" +
                    "                  bf_ishop_distributor_dispatch AS bidd ON biddp.distributor_dispatch_id = bidd.distributor_dispatch_id\n" +
                    "                  INNER JOIN\n" +
                    "                  table_scannedsticker ts ON ts.barcodeNo = biddp.btc_no_out\n" +
                    "            WHERE (biddp.is_valid = '1' OR \n" +
                    "                   biddp.is_valid = '2') AND \n" +
                    "                  ts.barcodeNo IS NOT NULL\n" +
                    "       )\n" +
                    "AND \n" +
                    "       (is_valid = '0' OR \n" +
                    "        is_valid = '2');\n";
        }
        db.execSQL(sql1);
    }

    /**
     * Opening Database
     */
    public SQLiteDatabase openDatabase() {
        /*if (Build.VERSION.SDK_INT >= 28) {
            db.disableWriteAheadLogging();
        }*/
        return writeDB();
    }


    public String getPasswordfromLogin(SQLiteDatabase db) {
        String password = "";
        String query;
        try {
            query = "select var_password from login";
            Cursor cursor = db.rawQuery(query, null);
            if (cursor != null && cursor.moveToFirst()) {
                do {
                    password = cursor.getString(cursor.getColumnIndex("var_password"));
                } while (cursor.moveToNext());
            }
            cursor.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        Log.v("TAG", "PASSWORD" + password);
        return password;
    }


//    public void updatePasswordEncrypted(SQLiteDatabase db) {
//        String pass = getPasswordfromLogin(db);
//        String email = getLoginEmailNew(db);
//        try {
//            String sql = "UPDATE login SET var_password = '" + AESCipher.encrypt(pass) + "' where  var_username = '" + email + "'";
//            db.execSQL(sql);
//            Content.setPreferenceValue(context, Const.KEY_PASSWORD, AESCipher.encrypt(pass));
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }


    public String getLoginEmailNew(SQLiteDatabase db) {
        String var_personname = "";
        Cursor cursor = db.rawQuery("Select var_username from login", null);
        if (cursor != null && cursor.getCount() > 0) {
            while (cursor.moveToNext()) {
                var_personname = cursor.getString(cursor.getColumnIndex("var_username"));
            }
        }
        cursor.close();
        return var_personname;
    }

    /**
     * Delete Rejected Record
     */
    public void deleteRejectedData() {
        SQLiteDatabase db = writeDB();
        String sql = "DELETE FROM bf_ishop_toller_dispatch where reject=1";
        db.execSQL(sql);

        String sql1 = "DELETE FROM bf_ishop_cfa_dispatch WHERE reject = 1";
        db.execSQL(sql1);

        db.close();
    }

    /**
     * Insert TransactionLog Error
     *
     * @param pagename
     * @param method_name
     * @param error_msg
     * @param stacktrace
     * @param error_code
     */
    public void insertTransactionErrorLog(Context context,
                                          String pagename,
                                          String method_name,
                                          String error_msg,
                                          String stacktrace,
                                          String error_code,
                                          String sync_log_id,String userID) {
        SQLiteDatabase database = writeDB();
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_TRANSACTION_ERROR_LOG +
                    " (" + DataBaseHelper.KEY_PAGE_NAME + ","
                    + DataBaseHelper.KEY_METHOD_NAME + ","
                    + DataBaseHelper.KEY_USER_ID + ","
                    + DataBaseHelper.KEY_ERROR_MSG + ","
                    + DataBaseHelper.KEY_STACKTRACE + ","
                    + DataBaseHelper.KEY_MODULE_NAME + ","
                    + DataBaseHelper.KEY_SOURCE_SYSTEM + ","
                    + DataBaseHelper.KEY_ERROR_FORM + ","
                    + DataBaseHelper.KEY_EXTRA1 + ","
                    + DataBaseHelper.KEY_EXTRA2 + ","
                    + DataBaseHelper.KEY_ERROR_CODE + ","
                    + DataBaseHelper.KEY_ERROR_DATE + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + DataBaseHelper.KEY_SYNC_PROCESS_ID
                    + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            try {
                SQLiteStatement statement = database.compileStatement(sql);
                statement.bindString(1, pagename);
                statement.bindString(2, method_name);
                statement.bindString(3, userID);
                statement.bindString(4, error_msg);
                statement.bindString(5, stacktrace);
                statement.bindString(6, "CPM Android");
                statement.bindString(7, "");
                statement.bindString(8, "");
                statement.bindString(9, sync_log_id);//sync_log_id
                statement.bindString(10, "");
                statement.bindString(11, error_code);
                statement.bindString(12, AppUtil.getCurrentDate(AppUtil.DATE_FORMAT));
                statement.bindString(13, AppUtil.getSyncCode(userID));
                statement.bindString(14, "Y");
                statement.bindString(15, AppUtil.getCurrentDate(AppUtil.DATE_FORMAT));
                statement.bindString(16, userID);
                statement.bindString(17, "");
                statement.execute();
                Log.e("TAG", "TABLE_TRANSACTION Added SUCCESSFULLY");
            } catch (Exception e) {
                e.printStackTrace();
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } finally {
            database.endTransaction();
        }
    }

    /**
     * Deleting Transaction Error Log Table
     */
    public void deleteTransactionErrorLog() {
        try {
            writeDB().execSQL("delete from " + DataBaseHelper.TABLE_TRANSACTION_ERROR_LOG);
            writeDB().close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    /**
     * http://teamvcspmt.ecubix.com:8080/browse/DP-6951
     * For the above Scenario
     *
     * @param user_id
     */
    public void updateTableIfRejectedAndGetByStockTransfer(String user_id) {
        SQLiteDatabase db = writeDB();
        try {
            String sql = "UPDATE table_scannedsticker\n" +
                    "   SET isValid = '1'\n" +
                    " WHERE sticker_details_id IN (\n" +
                    "    SELECT DISTINCT ts.sticker_details_id\n" +
                    "      FROM bf_ishop_distributor_return_request_product AS bidrp\n" +
                    "           INNER JOIN\n" +
                    "           bf_ishop_distributor_return_request AS bidr ON bidrp.distributor_return_request_id = bidr.distributor_return_request_id\n" +
                    "           INNER JOIN\n" +
                    "           bf_ishop_cfa_dispatch_product AS bicdp ON bicdp.sticker_details_id = bidrp.sticker_details_id\n" +
                    "           INNER JOIN\n" +
                    "           bf_ishop_cfa_dispatch AS bicd ON bicd.cfa_dispatch_id = bicdp.cfa_dispatch_id\n" +
                    "           LEFT JOIN\n" +
                    "           table_scannedsticker ts ON ts.sticker_details_id = bidrp.sticker_details_id\n" +
                    "     WHERE bidr.customer_to_id = '" + user_id + "' AND \n" +
                    "           (ifnull(bidrp.received, '0') = '0' OR \n" +
                    "            bidrp.received = '') AND \n" +
                    "           ts.barcodeNo IS NOT NULL AND \n" +
                    "           bicd.received_date  > bidrp.rejected_date ORDER BY bicd.received_date,bidrp.rejected_date DESC LIMIT 1\n" +
                    ");\n";
            Log.e("StickerReturned", "" + sql);
            db.execSQL(sql);
        } catch (Exception e) {
            Log.e("StickerReturned", "" + e.toString());
        }
    }

    /**
     * Get Pallet Detail ID Scanned From Temp Table With Barcode
     *
     * @return
     */
    public ArrayList<BarcodeModel> getScannedBarcode(int pallet_id) {
        ArrayList<BarcodeModel> listPalletId = new ArrayList<>();
        SQLiteDatabase db = writeDB();
        String query = "SELECT pallet_details_id FROM table_scannedsticker WHERE pallet_details_id=" + pallet_id + " AND show_in_list=0\n";

        Cursor cursor = db.rawQuery(query, null);
        try {
            if (cursor != null && cursor.moveToFirst()) {
                do {
                    BarcodeModel palletDetailModel = new BarcodeModel();
                    palletDetailModel.setPallet_detail_id(cursor.getInt(cursor.getColumnIndex("pallet_details_id")));

                    listPalletId.add(palletDetailModel);
                } while (cursor.moveToNext());
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (cursor != null) cursor.close();
        }
        return listPalletId;
    }

    /**
     * Delete entry from Cfa Dispatch that
     * is not in bf_ishop_cfa_dispatch_product table
     * Adde on 22 Jan 2020
     */
    public void deleteCfaDispatchIDNotInMainTable() {
        SQLiteDatabase db = writeDB();
        String sql = "DELETE FROM bf_ishop_cfa_dispatch_product\n" +
                "      WHERE cfa_dispatch_id NOT IN (\n" +
                "    SELECT bidp.cfa_dispatch_id\n" +
                "      FROM bf_ishop_cfa_dispatch AS bidp\n" +
                ");";
        db.execSQL(sql);
//        db.close();
    }

    public void deleteSampleMainTable() {
        try {
            writeDB().execSQL("delete from bf_ishop_sample_dispatch");
            writeDB().close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public void deleteSampleProductTable() {
        try {
            writeDB().execSQL("delete from bf_ishop_sample_dispatch_product");
            writeDB().close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public synchronized String getTransactionSyncDateAndTime() {
        String syncTime = "";
        try {
            SQLiteDatabase db = writeDB();
            String sql = "Select * from " + TABLE_Last_Sync_Date_Time;
            Cursor cursor = db.rawQuery(sql, null);
            if (cursor != null && cursor.getCount() > 0) {
                while (cursor.moveToNext()) {
                    syncTime = cursor.getString(cursor.getColumnIndex("Last_Sync_Date_Time_Trn_Get"));
                }
            }
            if (cursor != null) cursor.close();
            return syncTime;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return syncTime;
    }

    public void updateLastSyncDateTimeForWHMasterSync(JSONArray jsonArrayEmployee, int type) {
        if (jsonArrayEmployee.length() > 0) {
            try {
                SQLiteDatabase db = writeDB();
                String last_sync_date = getSyncDateAndTimeTransactionSync(type);

                db.execSQL("delete from " + DataBaseHelper.TABLE_Last_Sync_Date_Time);

                ContentValues contentValues = new ContentValues();
                if (type == 1) {
                    //For Transaction Sync
                    contentValues.put("Last_Sync_Date_Time_Trn_Get", jsonArrayEmployee.getJSONObject(0).getString("Last_Sync_Date"));
                    contentValues.put("Last_Sync_Date_Time", last_sync_date);
                } else {
                    //For Master Sync
                    contentValues.put("Last_Sync_Date_Time", jsonArrayEmployee.getJSONObject(0).getString("Last_Sync_Date"));
                    contentValues.put("Last_Sync_Date_Time_Trn_Get", last_sync_date);
                }

                long rowInserted = db.insert(DataBaseHelper.TABLE_Last_Sync_Date_Time, null, contentValues);
                LogHelper.printLog("TAG_SQLITE", "" + rowInserted);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

    }

    public synchronized String getSyncDateAndTimeTransactionSync(int type) {
        String syncTime = "";
        try {
            SQLiteDatabase db = writeDB();
            String sql = "Select * from " + TABLE_Last_Sync_Date_Time;
            Cursor cursor = db.rawQuery(sql, null);
            if (cursor != null && cursor.getCount() > 0) {
                while (cursor.moveToNext()) {
                    if (type == 1) {
                        syncTime = cursor.getString(cursor.getColumnIndex("Last_Sync_Date_Time"));
                    } else {
                        syncTime = cursor.getString(cursor.getColumnIndex("Last_Sync_Date_Time_Trn_Get"));
                    }

                }
            }
            if (cursor != null) cursor.close();
            if (syncTime == null || syncTime.equalsIgnoreCase("null")) {
                syncTime = "";
            }
            return syncTime;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return syncTime;
    }

    //Get B2C Configuration
    public String getB2CConfig() {
        String is_b2c = "";
        SQLiteDatabase db = getWritableDatabase();
        String sql = "SELECT is_b2c from b2c_config";
        Cursor cursor = db.rawQuery(sql, null);
        try {
            if (cursor != null && cursor.getCount() > 0) {
                while (cursor.moveToNext()) {
                    is_b2c = cursor.getString(0);
                    Log.e("is_b2c--databse--", is_b2c);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            cursor.close();
        }
        if (is_b2c.isEmpty()) {
            is_b2c = "N";
        }
        return is_b2c;
    }
}
