package ecp.vcs.com.ecpsyncplugin.re_sync.networking;

import static ecp.vcs.com.ecpsyncplugin.re_sync.model.ImeiInfo.getDeviceImei;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.Signature;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Build;
import android.os.StatFs;
import android.provider.Settings;
import android.util.Base64;
import android.util.Log;

import com.google.gson.Gson;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.nio.channels.FileChannel;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Locale;
import java.util.Random;

import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopCFADispatch;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopDistributorDispatch;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.LanguageModel;
import ecp.vcs.com.ecpsyncplugin.re_sync.storage.ScopedStorage;
import ecp.vcs.com.ecpsyncplugin.re_sync.database.DatabaseHelperExtended;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.Const;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.Content;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.SharedPreferenceHelper;
import okhttp3.OkHttpClient;
import okhttp3.logging.HttpLoggingInterceptor;

/**
 * File Name    : AppUtil
 * Description  : This Class for Declare and Define App AppUtil Methods.
 * Create By    : Value Chain Solution
 * Create At    : 30-05-2017.
 * Developed By : VCSDEV0114
 * Modified By  :
 * Feature      :
 *
 * @author Value Chain Solution
 */
public class AppUtil {
    static final String PREFS_NAME = "NOLEVElACTION";
    public static final String downloadDirectory = "RE_CPM_VIDEO_MANUAL";
//    public static ArrayList<RemainingStockBox> newremainingStockBoxes = new ArrayList<>();
    public static final String DATE_FORMAT = "yyyy-MM-dd HH:mm:ss";
    public static final String DATE_FORMAT2 = "HH:mm:ss";
    public static final String DATE_FORMAT3 = "yyyy-MM-dd";
    public static final String DATE_FORMAT4 = "dd/MM/yyyy";
    public static final String DATE_FORMAT5 = "dd-MM-yyyy HH:mm:ss";
    public static final String DATE_FORMAT6 = "dd-MM-yyyy";
//    public static IshopCFADamage wareHouseDetailsInfoCFADamage;
//    public static IshopDISTDamage wareHouseDetailsInfoDistDamage;
//    public static IshopRETDamage wareHouseDetailsInfoRetDamage;
    public static IshopCFADispatch wareHouseDetailsInfo;
//    public static IshopCFADispatch wareHouseDetailsInfoSCM;
    public static IshopCFADispatch wareHouseDetailsInfoStockTransfer;
    public static IshopDistributorDispatch retailerDetailsInfo;
//    public static IshopRetailerDispatchAll retailerDetailsInfoAll;
//    public static CreateNewCustomer newCustomerDetails;
    public static String distributorName;
    public static String distributorUserId;
    public static String newCustomerName;
    public static String whatSelected;
    public static String isComingFrom = "";
//    public static ArrayList<BarcodeModel> barcodeModels = new ArrayList<>();
    public static int receivedId = 0;
    public static int damageDispatchId = 0;
    public static String dispatchDate = "";
    public static String customerName = "";
    public static String customerId = "";
    public static String sripId = "";
    public static String skuId = "";
    public static int qtyRemaining = 0;
    public static int validCount = 0;
    public static String toIdCfa = "";
    public static String dispatchscantypenew = "";
    public static String retcfadispatchscantypenew = "";
    public static String login_id = "";
    public static String CUSTOMERFROMId = "";

    public static String insightLink = "";
    public static String reportLink = "";

    public static int distributorDispatchIdFirst = 0;
    public static int distributorDispatchIdLast = 0;

    public static int retailerReceiveIdFirst = 0;
    public static int retailerReceiveIdLast = 0;


    /**
     * R=Receive
     * D=Dispatch
     * SR=Sales Return
     * STF=Sale To Farmer
     * STR=Sale To Retailer
     */
    public static final String STOCK_TRANSFER = "ST";
    public static final String RECEIVE = "R";
    public static final String DISPATCH = "D";
    public static final String DISPATCH_SAMPLE_FOC = "SFOC";
    public static final String DIST_RETURN = "DR";
    public static final String SALES_RETURN = "SR";
    public static final String SALE_RETAILER = "STR";
    public static final String SALE_FARMER = "STF";
    public static String IS_FROM = "";
    public static final String DAMAGE = "DM";
    public static final String DIST_RETURN_RECEIVE = "DRR";
    public static String RETURN_FROM_DIST = "WH_R";

    /**
     * This method for check network is available  or not
     *
     * @param context
     * @return
     */
//    public static boolean isNetwork(Context context) {
//        ConnectivityManager cm =
//                (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
//        return cm.getActiveNetworkInfo() != null &&
//                cm.getActiveNetworkInfo().isConnectedOrConnecting();
//    }

    /**
     * This method for convert Object in JSON String.
     *
     * @param object
     * @return
     */
    public static String getJsonFromObject(Object object) {
        Gson gson = new Gson();
        return gson.toJson(object);
    }

    public static String getSyncCode(String userID) {
//        return Content.getUSerId(context) + "_" + System.currentTimeMillis() + getRandomNumber();
        return userID + "_" + System.currentTimeMillis() + getRandomNumber();
    }

    /**
     * get IMEI No(Unique) of the Device
     *
     * @return
     */
    public static String getIMEINo(Context context) {
//        TelephonyManager telephonyManager = (TelephonyManager) context.getSystemService(Context.TELEPHONY_SERVICE);
//        if (ActivityCompat.checkSelfPermission(context, Manifest.permission.READ_PHONE_STATE) != PackageManager.PERMISSION_GRANTED) {
//            // TODO: Consider calling
//            return "";
//        }
//        return telephonyManager.getDeviceId();

        return getDeviceImei(context);
    }

    public static String GetDeviceId(Context context) {
        return Settings.Secure.getString(context.getContentResolver(), Settings.Secure.ANDROID_ID);
    }

    /**
     * Get Device Details
     *
     * @param context
     * @return
     */
//    public static String getDeviceDetail(Context context) {
//
//        return "Version: " + getAppVersion(context) + " (" + "" + ")"
//                + " \nVersion Code: " + getVersionCode(context)
//                + " \nAndroid API: " + Build.VERSION.SDK_INT
//                + " \nUserName: " + Content.getPreferenceValue(context, Const.KEY_USER_ID) + ""
//                + " \nIMEI : " + getDeviceImei(context) + ""
//                + " \nMODEL : " + Build.MODEL + ""
//                + " \nMEMORY AVAILABLE : " + getTotalInternalMemorySize(context);
//    }

    /**
     * Get ISFrom
     */
    public static String getIsFrom(Context context) {
//        if (!AppUtil.IS_FROM.isEmpty()) {
//            SharedPreferenceHelper.setString(context, SharedPreferenceHelper.IS_FROM, AppUtil.IS_FROM);
//        }
        return SharedPreferenceHelper.getString(context,SharedPreferenceHelper.IS_FROM);
    }

//    public static void DisplayNetworkAlertMessage(Context context) {
//        try {
////            AlertDialog alertDialog = new AlertDialog.Builder(context).create();
//            AlertDialog alertDialog = new AlertDialog.Builder(new ContextThemeWrapper(context, R.style.Theme_AppCompat_Light)).create();
//            alertDialog.setTitle(context.getString(R.string.alert_popup));
//            alertDialog.setMessage(context.getResources().getString(R.string.strErrorNetworkConnection));
//            alertDialog.setButton(AlertDialog.BUTTON_NEUTRAL, context.getString(R.string.strOk),
//                    (dialog, which) -> dialog.dismiss());
//            alertDialog.show();
//        } catch (Resources.NotFoundException e) {
//            e.printStackTrace();
//        }
//    }

    // public static final String DATE_FORMAT = "HH:mm:ss";
    public static String getCurrentDate(String Format) {
        String Date = null;
        try {
            Calendar cal = new GregorianCalendar();
            DateFormat dateFormat = new SimpleDateFormat(Format, Locale.US);
            Date = dateFormat.format(cal.getTime());
        } catch (Exception e) {
            e.printStackTrace();
        }
        return Date;
    }

    public static String getRandomNumber() {
        try {
            final int min = 1000;
            final int max = 9999;
            final int random = new Random().nextInt((max - min) + 1) + min;
            Log.v("RANDOM NUMBER", String.valueOf(random));
            return String.valueOf(random);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
    }

    public static String getAppVersion(Context content) {
//        try {
//            PackageInfo pInfo = content.getPackageManager().getPackageInfo(content.getPackageName(), 0);
//            return pInfo.versionName;
//
//        } catch (PackageManager.NameNotFoundException e) {
//            e.printStackTrace();
//            return "";
//        }

        return "22.2.10001";
    }


    public static int getVersionCode(Context content) {
        try {
            PackageInfo pInfo = content.getPackageManager().getPackageInfo(content.getPackageName(), 0);
            return pInfo.versionCode;

        } catch (PackageManager.NameNotFoundException e) {
            e.printStackTrace();
            return 0;
        }

        //return "17.2.1";
    }

    public static void setLogToHttpClient(OkHttpClient.Builder httpClient) {
        httpClient.addInterceptor(setLogsToMethod());
    }

    //httpClient.addInterceptor(Utils.setLogsToMethod());
    private static HttpLoggingInterceptor setLogsToMethod() {
        HttpLoggingInterceptor logging = new HttpLoggingInterceptor();
        // set your desired log level
        logging.setLevel(HttpLoggingInterceptor.Level.BODY);

        return logging;
    }

    public static void copyFile(File src, File dst) throws IOException {
        FileChannel inChannel = new FileInputStream(src).getChannel();
        FileChannel outChannel = new FileOutputStream(dst).getChannel();
        try {
            inChannel.transferTo(0, inChannel.size(), outChannel);
        } finally {
            if (inChannel != null)
                inChannel.close();
            if (outChannel != null)
                outChannel.close();
        }
    }

    public static NetworkInfo getNetworkInfo(Context context) {
        ConnectivityManager cm = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
        return cm.getActiveNetworkInfo();
    }

    /**
     * This method for check network is available  or not
     *
     * @param context
     * @return
     */
    public static boolean isNetworkConnected(Context context) {
        ConnectivityManager cm =
                (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
        return cm.getActiveNetworkInfo() != null &&
                cm.getActiveNetworkInfo().isConnected();
    }


    public static long getMillisDifference(long startTime, long endTime) {
        return endTime - startTime;
    }

    public static String getAppVersionCode(Context content) {
        try {
            PackageInfo pInfo = content.getPackageManager().getPackageInfo(content.getPackageName(), 0);
            return String.valueOf(pInfo.versionCode);
        } catch (PackageManager.NameNotFoundException e) {
            e.printStackTrace();
            return "";
        }

        //return "17.2.1";
    }

    public static void deleteAllFiles(File root) {
        File[] files = root.listFiles();
        if (files != null && files.length > 0) {
            for (int i = 0; i < files.length; i++) {
                File myFile = files[i];
                if (myFile.exists())
                    myFile.delete();
            }
        }
    }

    public static String getRequestFileName(Context context,String userId) {
        String prefix = "jsonData_Android";
        try {
//            String userId = Content.getPreferenceValue(context, Const.KEY_USER_ID);
            prefix = prefix + "_" + userId + "_"+getRandomNumber()+"_";
            SimpleDateFormat sdf = new SimpleDateFormat("ddMMyyyyHHmmss", Locale.ENGLISH);
            String currentDateandTime = sdf.format(new Date());
            return prefix + currentDateandTime + ".txt";
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * Get Device Memory in MB
     *
     * @return
     */
    public static String getTotalInternalMemorySize(Context context) {
        try {
            StatFs stat = new StatFs(ScopedStorage.getInstance(context).getDirPath());
            long bytesAvailable;
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR2) {
                bytesAvailable = stat.getBlockSizeLong() * stat.getAvailableBlocksLong();
            } else {
                bytesAvailable = (long) stat.getBlockSize() * (long) stat.getAvailableBlocks();
            }
            long megAvailable = bytesAvailable / (1024 * 1024);

            Log.e("TAG_CPM_MEMORY", "Available MB : " + megAvailable);
            return "Available MB :" + megAvailable;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }

    /**
     * Get Full StackTrace of the Error Caused
     *
     * @param throwable
     * @return
     */
    public static String getStackTrace(final Throwable throwable) {
        try {
            final StringWriter sw = new StringWriter();
            final PrintWriter pw = new PrintWriter(sw, true);
            throwable.printStackTrace(pw);
            return sw.getBuffer().toString();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }


    /**
     * Get File Name From Extension
     *
     * @param filenamewithExtension
     * @return
     */
    public static String getFileName(String filenamewithExtension) {
        return filenamewithExtension.replace(".txt", "");
    }

    public static void delete(File fileOrDirectory) {
        if (fileOrDirectory.isDirectory())
            for (File child : fileOrDirectory.listFiles())
                delete(child);

        fileOrDirectory.delete();
    }


    public static String generateNoteOnSDForAll(String sFileName, String sBody, Context context, DatabaseHelperExtended databaseHelperExtended,String userID) {
        try {
            File root = ScopedStorage.getInstance(context).createDelete(ScopedStorage.EXTERNAL_STORAGE_RECPM_SYNC_REQUEST);
//            if (!root.exists()) {
//                root.mkdirs();
//            } else {
//                AppUtil.deleteAllFiles(root);
//            }
            File gpxfile = new File(root, sFileName);
            FileWriter writer = new FileWriter(gpxfile);
            writer.append(sBody);
            writer.flush();
            writer.close();

//            String filepath = Environment.getExternalStorageDirectory() + "/" + zipManager.REQUEST_FOLDER_SYNC + "/" + sFileName;
            return ScopedStorage.getInstance(context).getPath(ScopedStorage.EXTERNAL_STORAGE_RECPM_SYNC_REQUEST) + "/" + sFileName;
        } catch (IOException e) {
            e.printStackTrace();
            databaseHelperExtended.insertTransactionErrorLog(context, context.getClass().getSimpleName(), "callSyncAPI", AppUtil.getStackTrace(e), AppUtil.getStackTrace(e), "", "",userID);
        }
        return null;
    }

    /**
     * Get App Notification Icon For Pre Lollipop Devices and Latest
     *
     * @return
     */
//    public static int getNotificationIcon() {
//        boolean useWhiteIcon = (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP);
//        return useWhiteIcon ? R.mipmap.ic_notif_trans : R.mipmap.ic_launcher;
//    }

//    public static String getBaseURL(Context context) {
//        String basePath = "";
//        if (Const.BASE_URL.isEmpty()) {
//            basePath = ServerCofig.isLivePackageBasePath(context);
//            if (!basePath.isEmpty()) {
//                Const.BASE_URL = basePath;
//            } else {
//                basePath = ServerCofig.isIQAPackageBasePath(context);
//                if (!basePath.isEmpty()) {
//                    Const.BASE_URL = basePath;
//                } else {
//                    basePath = ServerCofig.isDEVPackageBasePath(context);
//                    if (!basePath.isEmpty()) {
//                        Const.BASE_URL = basePath;
//                    }
//                }
//
//            }
//        }
//
//        return basePath;
//    }

    public static Calendar getCalendar(Date date) {
        Calendar cal = Calendar.getInstance(Locale.ENGLISH);
        cal.setTime(date);
        return cal;
    }

    /**
     * Get Lang Data
     *
     * @return
     */
    public static ArrayList<LanguageModel> getLangList() {
        ArrayList<LanguageModel> list = new ArrayList<>();

        LanguageModel languageModel = new LanguageModel();
        languageModel.setLang_code("en");
        languageModel.setLang_name("english");
        list.add(languageModel);

        languageModel = new LanguageModel();
        languageModel.setLang_code("in");
        languageModel.setLang_name("bahasa");
        list.add(languageModel);

        languageModel = new LanguageModel();
        languageModel.setLang_code("th");
        languageModel.setLang_name("thai");
        list.add(languageModel);

        languageModel = new LanguageModel();
        languageModel.setLang_code("vi");
        languageModel.setLang_name("Vietnam");
        list.add(languageModel);

        return list;
    }

    private static String signatureDigest(Signature sig) {
        byte[] signature = sig.toByteArray();
        try {
            MessageDigest md = MessageDigest.getInstance("SHA1");
            byte[] digest = md.digest(signature);
            return new String(Base64.encode(digest, 0));
        } catch (NoSuchAlgorithmException e) {
            return null;
        }
    }
}

