import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'ecp_sync_plugin_platform_interface.dart';

/// An implementation of [EcpSyncPluginPlatform] that uses method channels.
class MethodChannelEcpSyncPlugin extends EcpSyncPluginPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('ecp_sync_plugin');

  @override
  Future<String?> getPlatformVersion() async {
    final version = await methodChannel.invokeMethod<String>('getPlatformVersion');
    return version;
  }
}
