import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'ecp_sync_plugin_method_channel.dart';

abstract class EcpSyncPluginPlatform extends PlatformInterface {
  /// Constructs a EcpSyncPluginPlatform.
  EcpSyncPluginPlatform() : super(token: _token);

  static final Object _token = Object();

  static EcpSyncPluginPlatform _instance = MethodChannelEcpSyncPlugin();

  /// The default instance of [EcpSyncPluginPlatform] to use.
  ///
  /// Defaults to [MethodChannelEcpSyncPlugin].
  static EcpSyncPluginPlatform get instance => _instance;
  
  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [EcpSyncPluginPlatform] when
  /// they register themselves.
  static set instance(EcpSyncPluginPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
